<?php
include(XOOPS_ROOT_PATH."/class/xoopsformloader.php");

function b_xfmod_show($options) {
  global $xoopsDB;
  $ts = MyTextSanitizer::getInstance();

  include(XOOPS_ROOT_PATH."/modules/xfmod/cache/config.php");
	
	$block = array();
	$block['title'] = "Latest XoopsForge News";
	$block['content'] = "";

	$limit          = $options[0];
	$show_summaries = ($options[1]==1?true:false);
	$flat           = ($options[2]==1?true:false);
	$tail_headlines = $options[3];
	
	$sql = "SELECT g.group_id,g.unix_group_name,g.group_name,g.type,u.uid,u.uname,nb.forum_id,nb.summary,nb.date,nb.details "
	      ."FROM ".$xoopsDB->prefix("users")." u,".$xoopsDB->prefix("xf_news_bytes")." nb,".$xoopsDB->prefix("xf_groups")." g "
				."WHERE nb.is_approved=1 "
				."AND u.uid=nb.submitted_by "
				."AND nb.group_id=g.group_id "
				."ORDER BY date DESC";

	$result = $xoopsDB->query($sql, $limit + $tail_headlines);
	$rows = $xoopsDB->getRowsNum($result);
	
	if (!$result || $rows < 1)
	{
		$block['content'] .= "<H4>No news items found</H4>";
		$block['content'] .= $xoopsDB->error();
	}
	else
	{
		$block['content'] .= "<DL COMPACT>";
		for ($i = 0; $i < $rows; $i++)
		{
		  $item = $xoopsDB->fetchArray($result);
			
			if ($show_summaries && $limit)
			{
				//get the first paragraph of the story
				$arr = explode("\n", $item['details']);
				//if the first paragraph is short, and so are following paragraphs, add the next paragraph on
				if ((strlen($arr[0]) < 200) && (strlen($arr[1].$arr[2]) < 300) && (strlen($arr[2]) > 5))
				{
					$summ_txt = "<BR>".$arr[0]."<BR>".$arr[1]."<BR>".$arr[2];
				}
				else
				{
					$summ_txt = "<BR>".$arr[0];
				}
				//show the project name
				if ($type == 2)
				{
					$group_type="/foundry";
				}
				else
				{
					$group_type="/project";
				}
				$proj_name = " &nbsp; - &nbsp; <A HREF='".XOOPS_URL."/xf".$group_type."/?".$item['unix_group_name']."'>".$item['group_name']."</A>";
			}
			else
			{
				$proj_name = "";
				$summ_txt = "";
			}

			if (!$limit)
			{
				$block['content'] .= "<li><A HREF='".XOOPS_URL."/xf/forum/forum.php?forum_id=".$item['forum_id']."'><B>".$ts->makeTareaData4Show($item['summary'])."</B></A>";
				$block['content'] .= " &nbsp; <I>".date(_SHORTDATESTRING, $date)."</I><br>";
			}
			else
			{
				$block['content'] .= "<A HREF='".XOOPS_URL."/xf/forum/forum.php?forum_id=".$item['forum_id']."'><B>".$ts->makeTareaData4Show($item['summary'])."</B></A>";
				if (!$flat)
				{
					$block['content'] .= "<BR>&nbsp;";
				}
				$block['content'] .= "&nbsp;&nbsp;&nbsp;<I><a href='".XOOPS_URL."/userinfo.php?uid=".$item['uid']."'>".$item['uname']."</a> - "
				                    .date(_SHORTDATESTRING, $item['date'])."</I>"
							   	          .$proj_name ."<BR />". $ts->makeTareaData4Show($summ_txt);

	      $sql = "SELECT COUNT(f.msg_id) AS count "
	            ."FROM ".$xoopsDB->prefix("xf_forum")." f,".$xoopsDB->prefix("xf_forum_group_list")." fgl "
				      ."WHERE f.group_forum_id=fgl.group_forum_id "
				      ."AND fgl.is_public=1 "
				      ."AND fgl.group_id=".$xoopsForge['sysnews']." "
							."AND f.group_forum_id=".$item['forum_id'];
							
				$res2 = $xoopsDB->query($sql);
				$xoopsDB2 = $xoopsDB->fetchArray($res2);
				$num_comments = $xoopsDB2['count'];

				if (!$num_comments)
				{
					$num_comments = '0';
				}

				if ($num_comments == 1)
				{
					$comments_txt = " Comment";
				}
				else
				{
					$comments_txt = " Comments";
				}

				$block['content'] .= "<div align='center'>(".$num_comments . $comments_txt.") [ <A HREF='".XOOPS_URL."/xf/forum/forum.php?forum_id=".$item['forum_id']."'>Read More/Comment</a> ]</div><HR width='100%' size='1' noshade>";
			}

			if ($limit == 1 && $tail_headlines)
			{
				$block['content'] .= "<ul>";
			}
			if ($limit)
			{
				$limit--;
			}
		}
	}

	if ($tail_headlines) {
		$block['content'] .= "</ul><HR width='100%' size='1' noshade>\n";
	}

	$block['content'] .= "<div align='center'>"
	                    ."[ <a href='".XOOPS_URL."/xf/news/'>News Archive</a> ]</div>";

	return $block;
}

function b_xfmod_edit($options) {
  $summaries = new XoopsFormRadioYN("Show Summaries", "options[1]", $options[1]);
  $flat      = new XoopsFormRadioYN("Show Flat",      "options[2]", $options[2]);
	$form  = "Limit Headlines&nbsp;<input type='text' name='options[]' value='".$options[0]."' />&nbsp;articles<br />";
	$form .= "Show Summaries&nbsp;".$summaries->render()."<br />";
	$form .= "Show Flat&nbsp;".$flat->render()."<br />";
	$form .= "Tail Headlines&nbsp;<input type='text' name='options[]' value='".$options[3]."' />&nbsp;articles";

	return $form;
}

function b_xfmod_stats ($options)
{
  include(XOOPS_ROOT_PATH."/modules/xfmod/cache/config.php");

  $xoopsDB =& Database::getInstance();
	
	$block = array();
	$block['title'] = "XoopsForge Statistics";
	$block['content'] = "";
	
  $old_date = time() - 60 * 60 * 24 * 14;
	$res_pending = $xoopsDB->query("SELECT COUNT(*) AS count "
	                         ."FROM ".$xoopsDB->prefix("xf_news_bytes")." nb,".$xoopsDB->prefix("xf_groups")." g "
								           ."WHERE is_approved=0 "
								           ."AND nb.group_id=g.group_id "
								           ."AND date > '$old_date' "
								           ."AND g.is_public=1 "
								           ."AND g.status='A'");
  if ($res_pending) {
	  list ($count) = $xoopsDB->fetchRow ($res_pending);
		$block['content'] .= "<strong><big>&middot;</big></strong>&nbsp;<a href='".XOOPS_URL."/xf/news/admin/'>Pending News Items</a>: ".$count."<br />\n";
	}
	
	if ($xoopsForge['manapprove'] == 1) {
	  $res_projects = $xoopsDB->query("SELECT COUNT(*) AS count FROM ".$xoopsDB->prefix("xf_groups")." WHERE status='P' AND group_id<>100");
    if ($res_projects) {
	    list ($count) = $xoopsDB->fetchRow ($res_projects);
		  $block['content'] .= "<strong><big>&middot;</big></strong>&nbsp;<a href='".XOOPS_URL."/modules/xfmod/admin.php?fct=groups&op=GroupApprove'>Pending Projects</a>: ".$count."<br />\n";
	  }
	} else {
	  $block['content'] .= "<strong><big>&middot;</big></strong>&nbsp;Manual Approval disabled<br />\n";
	}
	
	return $block;
}
?>
