<?php
/**
 * project_summary.php
 *
 * SourceForge: Breaking Down the Barriers to Open Source Development
 * Copyright 1999-2001 (c) VA Linux Systems
 * http://sourceforge.net
 *
 * @version   $Id: project_summary.php,v 1.4 2002/06/07 09:17:34 arjenvanefferen Exp $
 */

$project_agg_arr=array();
/**
 * project_get_mail_list_count() - Get the number of mailing lists for a project.
 *
 * @param		int		The group ID
 */
function project_get_mail_list_count($group_id) {
	return project_getaggvalue($group_id,'mail'); 
}

/**
 * project_get_survey_count() - Get the number of surveys for a project.
 *
 * @param		int		The group ID
 */
function project_get_survey_count($group_id) {
  global $xoopsDB;
	
	$sql = "SELECT COUNT(*) AS count "
	      ."FROM ".$xoopsDB->prefix("xf_surveys")." "
				."WHERE is_active=1 "
				."AND group_id=$group_id";
	
	return unofficial_getDBResult($xoopsDB->query($sql),0,'count');
}	   

/**
 * project_get_public_forum_count() - Get the number of public forums for a project.
 *
 * @param		int		The group ID
 */
function project_get_public_forum_count($group_id) {
  global $xoopsDB;
	
	$sql = "SELECT COUNT(*) AS count "
	      ."FROM ".$xoopsDB->prefix("xf_forum_group_list")." "
				."WHERE is_public=1 "
				."AND group_id=$group_id";
	
	return unofficial_getDBResult($xoopsDB->query($sql),0,'count');
}

/**
 * project_get_public_forum_message_count() - Get the number of messages within public forums for a project.
 *
 * @param		int		The group ID
 */
function project_get_public_forum_message_count($group_id) {
  global $xoopsDB;
	
	$sql = "SELECT COUNT(f.msg_id) AS count "
	      ."FROM ".$xoopsDB->prefix("xf_forum")." f,".$xoopsDB->prefix("xf_forum_group_list")." fgl "
				."WHERE f.group_forum_id=fgl.group_forum_id "
				."AND fgl.is_public=1 "
				."AND fgl.group_id=$group_id";

	return unofficial_getDBResult($xoopsDB->query($sql),0,'count');
}
	/**
	 *	tab_entry() - Prints out the a themed tab, used by project_tabs
	 *
	 *	@param	string	Is the URL to link to
	 *	@param	string	Us the image to use (if the theme uses it)
	 *	@param	string	Is the title to use in the link tags
	 *	@param	bool	Is a boolean to test if the tab is 'selected'
	 */
	function tab_entry($url='http://localhost/', $icon='', $title='Home', $selected=0) {
		echo "<A href='".$url."'>";
		if ($selected)
		{
		  echo "<b>".$title."</b>";
		}
		else
		{
		  echo $title;
		}
		echo "</A>&nbsp;|&nbsp;";
	}

	/**
	 *	project_tabs() - Prints out the project tabs, contained here in case
	 *		we want to allow it to be overriden
	 *
	 *	@param	string	Is the tab currently selected
	 *	@param	string	Is the group we should look up get title info
	 *  @param	string	Any extra text to print out
	 */
	function project_tabs($toptab,$group,$extra_text='') {
	  global $xoopsDB;
		// get group info using the common result set
		$project =& group_get_object($group);
		if ($project->isError()) {
			//wasn't found or some other problem
			return;
		}
		if (!$project->isProject()) {
			return;
		}

		echo "<HR SIZE='1' NoShade>";
		// Summary
		tab_entry(XOOPS_URL."/xf/project/?".$project->getUnixName(),
		          '', _XF_G_SUMMARY, $toptab == "home");

		// Project Admin 
		tab_entry(XOOPS_URL.'/xf/project/admin/?group_id='.$group,
		          '',
							_XF_G_ADMIN,
							$toptab == 'admin');

		// Homepage
		tab_entry('http://'.$project->getHomePage(),
		          '',
							_XF_G_HOMEPAGE);

		// Forums
		if ($project->usesForum()) {
		  tab_entry(XOOPS_URL.'/xf/forum/?group_id='.$group,
		                   '',
										   _XF_G_FORUMS,
										   $toptab == 'forums');
		}

		// Artifact Tracking
		tab_entry(XOOPS_URL.'/xf/tracker/?group_id='.$group,
		                 '',
										 _XF_G_TRACKERS,
										 $toptab == 'tracker');

		$res = $xoopsDB->query("SELECT * "
		                       ."FROM ".$xoopsDB->prefix("xf_artifact_group_list")." "
													 ."WHERE group_id='$group' "
													 ."AND is_public='1' "
													 ."AND datatype > 0 "
													 ."ORDER BY datatype ASC");
		$rows = $xoopsDB->getRowsNum($res);
//
//	Iterate through the public pre-defined trackers and add them to nav bar
//
		for ($i = 0; $i < $rows; $i++) {
			if (unofficial_getDBResult($res, $i, 'datatype') == 1) {
				//bug Tracker
		    tab_entry(XOOPS_URL.'/xf/tracker/?group_id='.$group.'&atid='.unofficial_getDBResult($res,$i,'group_artifact_id'),
		                     '',
										     _XF_G_BUGS,
										     $toptab == 'bugs');
			} elseif (unofficial_getDBResult($res,$i,'datatype') == 2) {
				//support Tracker
		    tab_entry(XOOPS_URL.'/xf/tracker/?group_id='.$group.'&atid='.unofficial_getDBResult($res,$i,'group_artifact_id'),
		                     '',
										     _XF_G_SUPPORT,
										     $toptab == 'support');
			} elseif (unofficial_getDBResult($res,$i,'datatype') == 3) {
				//patch Tracker
		    tab_entry(XOOPS_URL.'/xf/tracker/?group_id='.$group.'&atid='.unofficial_getDBResult($res,$i,'group_artifact_id'),
		                     '',
										     _XF_G_PATCHES,
										     $toptab == 'patch');
			}
		}

		// Project Manager
		if ($project->usesPm()) {
      tab_entry(XOOPS_URL.'/xf/pm/?group_id='.$group,
	                     '',
									     _XF_G_TASKS,
									     $toptab == 'pm');
		}

		// Doc Manager
		if ($project->usesDocman()) {
      tab_entry(XOOPS_URL.'/xf/docman/?group_id='.$group,
	                     '',
									     _XF_G_DOCS,
									     $toptab == 'docman');
		}

		// Surveys
		if ($project->usesSurvey()) {
      tab_entry(XOOPS_URL.'/xf/survey/?group_id='.$group,
	                     '',
									     _XF_G_SURVEYS,
									     $toptab == 'surveys');
		}

		//newsbytes
		if ($project->usesNews()) {
      tab_entry(XOOPS_URL.'/xf/news/?group_id='.$group,
	                     '',
									     _XF_G_NEWS,
									     $toptab == 'news');
		}

		// Downloads
    tab_entry(XOOPS_URL.'/xf/project/showfiles.php?group_id='.$group,
                     '',
								     _XF_G_FILES,
								     $toptab == 'downloads');

		echo "<HR SIZE='1' NoShade><BR>";
	}
	
	function project_check_access ($group_id) {
	  global $xoopsUser;
		
		if (!$group_id || $group_id == "" || !$group_id > 0) {
	    redirect_header(XOOPS_URL, 4, _NOPERM);
	    exit;
		}
		
		if (!$xoopsUser) {
	    redirect_header(XOOPS_URL, 4, _NOPERM);
	    exit;
		}
		
		$group =& group_get_object($group_id);
    $perm  =& $group->getPermission( $xoopsUser );
		
		if (!$group->isActive() && !$perm->isSuperUser()) {
		  redirect_header(XOOPS_URL,4,_XF_PRJ_NOTAUTHORIZEDTOENTER);
		  exit;
		}
		
		if (!$perm->isMember('user_id', $xoopsUser->getVar('uid'))) {
	    redirect_header(XOOPS_URL,4,_XF_G_PERMISSIONDENIED."<br />"._XF_PRJ_NOTMEMBEROFPROJECT);
	    exit;
		}
	}

?>
