<?php
/**
 * trove.php
 *
 * SourceForge: Breaking Down the Barriers to Open Source Development
 * Copyright 1999-2001 (c) VA Linux Systems
 * http://sourceforge.net
 *
 * @version   $Id: trove.php,v 1.4 2002/06/17 08:14:33 arjenvanefferen Exp $
 */

// ################################## Trove Globals

$TROVE_MAXPERROOT = 3;
$TROVE_BROWSELIMIT = 20;
$TROVE_HARDQUERYLIMIT = -1;

// ##################################

/**
 * trove_genfullpaths() - Regenerates full path entries for $node and all subnodes
 *
 * @param		int		The node
 * @param		string	The full path for this node
 * @param		int		The full path IDs
 */
function trove_genfullpaths($mynode,$myfullpath,$myfullpathids) {
  global $xoopsDB;
	
	// first generate own path
	$res_update = $xoopsDB->queryF("UPDATE ".$xoopsDB->prefix("xf_trove_cat")." SET "
	                              ."fullpath='".$myfullpath."',"
																."fullpath_ids='".$myfullpathids."' "
																."WHERE trove_cat_id=".$mynode);
																
	// now generate paths for all children by recursive call
	$res_child = $xoopsDB->query("SELECT trove_cat_id,fullname "
	                             ."FROM ".$xoopsDB->prefix("xf_trove_cat")." "
															 ."WHERE parent='".$mynode."'");

	while ($row_child = $xoopsDB->fetchArray($res_child)) {
		trove_genfullpaths($row_child['trove_cat_id'],
			                 $myfullpath." :: ".$row_child['fullname'],
			                 $myfullpathids." :: ".$row_child['trove_cat_id'] );
	}
}

// #########################################

/**
 * trove_setnode() - Adds a group to a trove node
 *
 * @param		int		The group ID
 * @param		int		The trove category ID
 * @param		int		The root node
 */
function trove_setnode($group_id,$trove_cat_id,$rootnode=0) {
  global $xoopsDB;
	// verify we were passed information
	if ((!$group_id) || (!$trove_cat_id))
	  return 1;

	// verify trove category exists
	$res_verifycat = $xoopsDB->query("SELECT trove_cat_id,fullpath_ids "
	                                 ."FROM ".$xoopsDB->prefix("xf_trove_cat")." "
																	 ."WHERE trove_cat_id='$trove_cat_id'");

	if ($xoopsDB->getRowsNum($res_verifycat) != 1)
	  return 1;
		
	$row_verifycat = $xoopsDB->fetchArray($res_verifycat);

	// if we didnt get a rootnode, find it
	if (!$rootnode) {
		$rootnode = trove_getrootcat($trove_cat_id);
	}

	// must first make sure that this is not a subnode of anything current
	$res_topnodes = $xoopsDB->query("SELECT tc.trove_cat_id AS trove_cat_id,tc.fullpath_ids AS fullpath_ids "
	                                ."FROM ".$xoopsDB->prefix("xf_trove_cat")." tc,".$xoopsDB->prefix("xf_trove_group_link")." tgl "
																	."WHERE tc.trove_cat_id=tgl.trove_cat_id "
																	."AND tgl.group_id='$group_id' "
																	."AND tc.root_parent='$rootnode'");

	while($row_topnodes = $xoopsDB->fetchArray($res_topnodes)) {
		$pathids = explode(' :: ',$row_topnodes['fullpath_ids']);
		for ($i=0; $i<count($pathids); $i++) {
			// anything here will invalidate this setnode
			if ($pathids[$i] == $trove_cat_id) {
				return 1;
			}
		}
	}

	// need to see if this one is more specific than another
	// if so, delete the other and proceed with this insertion
	$subnodeids = explode(' :: ',$row_verifycat['fullpath_ids']);
	$res_checksubs = $xoopsDB->query("SELECT trove_cat_id "
	                                 ."FROM ".$xoopsDB->prefix("xf_trove_group_link")." "
																	 ."WHERE group_id='$group_id' "
																	 ."AND trove_cat_root='$rootnode'");

	while ($row_checksubs = $xoopsDB->fetchArray($res_checksubs)) {
		// check against all subnodeids
		for ($i=0; $i < count($subnodeids); $i++) {
			if ($subnodeids[$i] == $row_checksubs['trove_cat_id']) {
				// then delete subnode
				$xoopsDB->queryF("DELETE FROM ".$xoopsDB->prefix("xf_trove_group_link")." "
				                ."WHERE group_id=".$group_id." AND trove_cat_id=".$subnodeids[$i]);
			}
		}
	}

	// if we got this far, must be ok
	$xoopsDB->queryF("INSERT INTO ".$xoopsDB->prefix("xf_trove_group_link")." (trove_cat_id,trove_cat_version,group_id,trove_cat_root) VALUES ("
	                ."'".$trove_cat_id."',"
									."'".time()."',"
									."'".$group_id."',"
									."'".$rootnode."')");
	return 0;
}

/**
 * trove_getrootcat() - Get the root categegory
 *
 * @param		int		Trove category ID
 */
function trove_getrootcat($trove_cat_id) {
  global $xoopsDB;
	
	$parent = 1;
	$current_cat = $trove_cat_id;

	while ($parent > 0) {
		$res_par = $xoopsDB->query("SELECT parent "
		                           ."FROM ".$xoopsDB->prefix("xf_trove_cat")." "
															 ."WHERE trove_cat_id='$current_cat'");

		$row_par = $xoopsDB->fetchArray($res_par);
		
		$parent = $row_par["parent"];
		
		if ($parent == 0)
		  return $current_cat;
			
		$current_cat = $parent;
	}

	return 0;
}

/**
 * trove_getallroots() - Returns an associative array of all project roots
 */
function trove_getallroots() {
  global $xoopsDB;
	
	$res = $xoopsDB->query("SELECT trove_cat_id,fullname "
	                       ."FROM ".$xoopsDB->prefix("xf_trove_cat")." "
												 ."WHERE parent=0");

	while ($row = $xoopsDB->fetchArray($res)) {
		$tmpcatid = $row["trove_cat_id"];
		$CATROOTS[$tmpcatid] = $row["fullname"];
	}
	return $CATROOTS;
}

/**
 * trove_catselectfull() - Returns full select output for a particular root
 *
 * @param		int		The node
 * @param		string	The category to pre-select
 * @param		string	THe select-box name
 */
function trove_catselectfull($node,$selected,$name) {
  global $xoopsDB;
	
	echo "<BR><SELECT name='$name'>";
	echo "  <OPTION value='0'>"._XF_TRV_NONESELECTED;
	$res_cat = $xoopsDB->query("SELECT trove_cat_id,fullpath "
	                           ."FROM ".$xoopsDB->prefix("xf_trove_cat")." "
														 ."WHERE root_parent='$node' "
														 ."ORDER BY fullpath");

	while ($row_cat = $xoopsDB->fetchArray($res_cat)) {
		echo "  <OPTION value='".$row_cat['trove_cat_id']."'";
		if ($selected == $row_cat['trove_cat_id']) echo " selected";
		echo ">".$row_cat['fullpath']."\n";
	}
	echo "</SELECT>\n";
}

/**
 * trove_getcatlisting() - Gets discriminator listing for a group
 *
 * @param		int		The group ID
 * @param		bool	Whether filters have already been applied
 * @param		bool	Whether to print category links
 */
function trove_getcatlisting($group_id,$a_filter,$a_cats) {
	global $discrim_url;
	global $expl_discrim;
	global $form_cat;
	global $xoopsDB;

	$res_trovecat = $xoopsDB->query("SELECT tc.fullpath AS fullpath,tc.fullpath_ids AS fullpath_ids,tc.trove_cat_id AS trove_cat_id "
	                               ."FROM ".$xoopsDB->prefix("xf_trove_cat")." tc,".$xoopsDB->prefix("xf_trove_group_link")." tgl "
																 ."WHERE tc.trove_cat_id=tgl.trove_cat_id "
																 ."AND tgl.group_id='$group_id' "
																 ."ORDER BY tc.fullpath");

	if ($xoopsDB->getRowsNum($res_trovecat) < 1) {
		print _XF_TRV_NONYETCATEGORIZED.' '
			.'<A href="'.XOOPS_URL.'/modules/xfsoftware/trove_list.php">Trove '
			.'Software Map</A>.';
	}

	// first unset the vars were using here
	$proj_discrim_used='';
	$isfirstdiscrim = 1;
	echo '<UL>';
	while ($row_trovecat = $xoopsDB->fetchArray($res_trovecat)) {
		$folders = explode(" :: ",$row_trovecat['fullpath']);
		$folders_ids = explode(" :: ",$row_trovecat['fullpath_ids']);
		$folders_len = count($folders);
		// if first in discrim print root category
		if (!$proj_discrim_used[$folders_ids[0]]) {
			if (!$isfirstdiscrim) print '<BR>';
				print ('<LI> '.$folders[0].': ');
		}

		// filter links, to add discriminators
		// first check to see if filter is already applied
		$filterisalreadyapplied = 0;
		for ($i=0;$i<sizeof($expl_discrim);$i++) {
			if ($folders_ids[$folders_len-1] == $expl_discrim[$i])
				$filterisalreadyapplied = 1;
			}
			// then print the stuff
			if ($proj_discrim_used[$folders_ids[0]]) print ', ';

			if ($a_cats) print '<A href="'.XOOPS_URL.'/modules/xfsoftware/trove_list.php?form_cat='
				.$folders_ids[$folders_len-1].$discrim_url.'">';
			print ($folders[$folders_len-1]);
			if ($a_cats) print '</A>';

			if ($a_filter) {
				if ($filterisalreadyapplied) {
					print ' <b>('._XF_TRV_NOWFILTERING.')</b> ';
				} else {
					print ' <A href="'.XOOPS_URL.'/modules/xfsoftware/trove_list.php?form_cat='
						.$form_cat;
					if ($discrim_url) {
						print $discrim_url.','.$folders_ids[$folders_len-1];
					} else {
						print '&discrim='.$folders_ids[$folders_len-1];
					}
					print '">['._XF_TRV_FILTER.']</A> ';
				}
			}
		$proj_discrim_used[$folders_ids[0]] = 1;
		$isfirstdiscrim = 0;
	}
	echo '</UL>';
}

/**
 * trove_getfullname() - Returns cat fullname
 *
 * @param		int		The node
 */
function trove_getfullname($node) {
  global $xoopsDB;
	
	$res = $xoopsDB->query("SELECT fullname FROM ".$xoopsDB->prefix("xf_trove_cat")." WHERE trove_cat_id='$node'");
	$row = $xoopsDB->fetchArray($res);
	return $row['fullname'];
}

/**
 * trove_getfullpath() - Returns a full path for a trove category
 *
 * @param		int		The node
 */
function trove_getfullpath($node) {
  global $xoopsDB;
	$currentcat = $node;
	$first = 1;
	$return = '';

	while ($currentcat > 0) {
		$res = $xoopsDB->query("SELECT trove_cat_id,parent,fullname "
		                       ."FROM ".$xoopsDB->prefix("xf_trove_cat")." "
													 ."WHERE trove_cat_id='$currentcat'");
													 
		$row = $xoopsDB->fetchArray($res);
		$return = $row["fullname"] . ($first ? "" : " :: ") . $return;
		$currentcat = $row["parent"];
		$first = 0;
	}
	return $return;
}

?>
