<?php
function frsGetNoticeMessage ($unix_group,$full_group,$package,$date,$group_id,$release_id,$package_id)
{
  global $xoopsConfig;
	
  $message = array();
	$message['subject'] = "[XoopsForge "._XF_FRS_RELEASE."] ".$unix_group." : ".$package;
		
  $message['body'] = "Project: ".$full_group."  (".$unix_group.")\n"
	                  ."Package: ".$package."\n"
										."Date   : ".$date."\n"
										."\n"
										."Project '".$full_group."' ('".$unix_group."') has "
										."released the new version of package '".$package."'. "
										."You can download it from XoopsForge "
										."by following this link:\n"
										."<".$xoopsConfig['xoops_url']."/xf/project/showfiles.php?group_id=".$group_id."&release_id=".$release_id.">\n"
										."or browse Release Notes and ChangeLog by visiting this link:\n"
										."<".$xoopsConfig['xoops_url']."/xf/project/shownotes.php?release_id=".$release_id.">\n"
										."\n"
										."You receive this email because you "
										."requested to be notified when new versions of this package "
										."were released. If you don't wish to be notified in the "
										."future, please login to XoopsForge and click this link: "
										."<".$xoopsConfig['xoops_url']."/xf/project/filemodule_monitor.php?filemodule_id=".$package_id.">\n";
										
  return $message;
}

function grpGetApprovalMessage($unix_group,$full_group,$group_id)
{
  global $xoopsConfig;

  $message = array();
	$message['subject'] = "XoopsForge Project Approved";

  $message['body'] = "Your project registration for XoopsForge has been approved.\n"
	                  ."\n"
										."Project Full Name: ".$full_group."\n"
										."Project Unix Name: ".$unix_group."\n"
										."\n"
										."Please take some time to read the site documentation about project "
										."administration (<".$xoopsConfig['xoops_url']."/modules/xfmod/index.php?op=docs&group_id=1>). If you visit your "
										."own project page in XoopsForge while logged in, you will find "
										."additional menu functions to your left labeled 'Project Admin'\n"
										."\n"
										."We highly suggest that you now visit XoopsForge and create a public "
										."description for your project. This can be done by visiting your project "
										."page while logged in, and selecting 'Project Admin' from the menus "
										."on the left (or by visiting <".$xoopsConfig['xoops_url']."/xf/project/admin/?group_id=".$group_id."> "
										."after login)\n"
										."\n"
										."Your project will also not appear in the Trove Software Map (primary "
										."list of projects hosted on XoopsForge which offers great flexibility in "
										."browsing and search) until you categorize it in the project administration "
										."screens. So that people can find your project, you should do this now. "
										."Visit your project while logged in, and select 'Project Admin' from the "
										."menus on the left.\n"
										."\n"
										."Enjoy the system, and please tell others about XoopsForge. Let us know "
										."if there is anything we can do to help you.\n"
										."\n"
										." -- the XoopsForge crew";
										
  return $message;
}

function grpGetDeniedMessage($unix_group,$full_group)
{
  global $xoopsConfig;

  $message = array();
	$message['subject'] = "XoopsForge Project Denied";
		
  $message['body'] = "Your project registration for XoopsForge has been denied.\n"
	                  ."\n"
										."Project Full Name: ".$full_group."\n"
										."Project Unix Name: ".$unix_group."\n"
										."\n"
										."Reasons for negative decision:\n";
										
  return $message;
}

function frmGetMonitorMessage($msg_id, $uname, $body, $forum_id, $unix_group_name,$forum_name, $subject)
{
  global $xoopsConfig;
	
  $message = array();
	$message['subject'] = "[".$unix_group_name." - ".$forum_name."] ".$subject;
		
  $message['body'] = "\n"
	                  ."Read and respond to this message at:\n"
										."<".$xoopsConfig['xoops_url']."/xf/forum/message.php?msg_id=".$msg_id.">\n"
										."By: ".$uname."\n"
										."\n"
										.$body."\n"
										."\n"
										."______________________________________________________________________\n"
										."You are receiving this email because you selected to monitor this forum.\n"
										."To stop monitoring this forum, login to SourceForge and visit:\n"
										."<".$xoopsConfig['xoops_url']."/xf/forum/monitor.php?forum_id=".$forum_id.">";
										
  return $message;
}

function myGetDiaryMessage($uname, $summary, $details, $uid)
{
  global $xoopsConfig;
	
  $message = array();
	$message['subject'] = "[ XF User Notes: ".$uname."] ".stripslashes($summary);
		
  $message['body'] = "\n"
	                  .stripslashes($details)."\n"
										."\n"
										."______________________________________________________________________\n"
										."You are receiving this email because you selected to monitor this user.\n"
										."To stop monitoring this user, login to XoopsForge and visit:\n"
										."<".$xoopsConfig['xoops_url']."/xf/developer/monitor.php?diary_user=".$uid.">";
										
  return $message;
}
?>