<?php
/**
  *
  * SourceForge Jobs (aka Help Wanted) Board
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: editjob.php,v 1.3 2002/05/30 22:06:32 arjenvanefferen Exp $
  *
  */

include_once ("../../mainfile.php");

$langfile="people.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/include/project_summary.php");
require_once(XOOPS_ROOT_PATH."/xf/people/people_utils.php");

if ($group_id && $group_id != '') {

  $group =& group_get_object($group_id);
  $perm  =& $group->getPermission( $xoopsUser );

  if (!$perm->isAdmin() && !$perm->isSuperUser())
  {
    redirect_header($GLOBALS["HTTP_REFERER"],4,_XF_G_PERMISSIONDENIED."<br />"._XF_PRJ_NOTADMINTHISPROJECT);
    exit;
  }

  if ($add_job) {
    /*
      create a new job
    */
    if (!$title || !$description || $category_id==100) {
      //required info
      echo _XF_PEO_FILLINALLFIELDS;
      exit;
    }

    $sql = "INSERT INTO ".$xoopsDB->prefix("xf_people_job")." (group_id,created_by,title,description,date,status_id,category_id) "
          ."VALUES ('$group_id','".$xoopsUser->getVar("uid")."','".$ts->makeTboxData4Save($title)."','".$ts->makeTareaData4Save($description)."','".time()."','1','$category_id')";

    $result = $xoopsDB->queryF($sql);

    if (!$result) {
      $feedback .= ' JOB insert FAILED ';
      echo $xoopsDB->error();
    } else {
      $job_id = $xoopsDB->getInsertId();
      $feedback .= ' '._XF_PEO_JOBINSERTED.' ';
    }
  } else if ($update_job) {
    /*
      update the job's description, status, etc
    */
    if (!$title || !$description || $category_id==100 || $status_id==100 || !$job_id) {
      //required info
      //required info
      echo _XF_PEO_FILLINALLFIELDS;
      exit;
    }

    $sql = "UPDATE ".$xoopsDB->prefix("xf_people_job")." SET "
          ."title='".$ts->makeTboxData4Save($title)."',"
          ."description='".$ts->makeTareaData4Save($description)."',"
          ."status_id='$status_id',"
          ."category_id='$category_id' "
          ."WHERE job_id='$job_id' "
          ."AND group_id='$group_id'";

    $result = $xoopsDB->queryF($sql);

    if (!$result) {
      $feedback .= ' JOB update FAILED ';
      echo $xoopsDB->error();
    } else {
      $feedback .= ' '._XF_PEO_JOBUPDATED.' ';
    }

  } else if ($add_to_job_inventory) {
    /*
      add item to job inventory
    */
    if ($skill_id==100 || $skill_level_id==100 || $skill_year_id==100  || !$job_id) {
      //required info
      echo _XF_PEO_FILLINALLFIELDS;
      exit;
    }

    if (people_verify_job_group($job_id,$group_id)) {
      people_add_to_job_inventory($job_id,$skill_id,$skill_level_id,$skill_year_id);
      $feedback .= ' '._XF_PEO_JOBUPDATED.' ';
    } else {
      $feedback .= ' JOB update failed - wrong project_id ';
    }
  } else if ($update_job_inventory) {
    /*
      Change Skill level, experience etc.
    */
    if ($skill_level_id==100 || $skill_year_id==100  || !$job_id || !$job_inventory_id) {
      //required info
      echo _XF_PEO_FILLINALLFIELDS;
      exit;
    }

    if (people_verify_job_group($job_id,$group_id)) {
      $sql = "UPDATE ".$xoopsDB->prefix("xf_people_job_inventory")." SET "
            ."skill_level_id='$skill_level_id',"
            ."skill_year_id='$skill_year_id' "
            ."WHERE job_id='$job_id' "
            ."AND job_inventory_id='$job_inventory_id'";

      $result = $xoopsDB->queryF($sql);

      if (!$result) {
        $feedback .= ' JOB skill update FAILED ';
        echo $xoopsDB->error();
      } else {
        $feedback .= ' '._XF_PEO_JOBSKILLUPDATED.' ';
      }
    } else {
      $feedback .= ' JOB skill update failed - wrong project_id ';
    }
  } else if ($delete_from_job_inventory) {
    /*
      remove this skill from this job
    */
    if (!$job_id) {
      //required info
      echo _XF_PEO_FILLINALLFIELDS;
      exit;
    }

    if (people_verify_job_group($job_id,$group_id)) {
      $sql = "DELETE FROM ".$xoopsDB->prefix("xf_people_job_inventory")." "
            ."WHERE job_id='$job_id' "
            ."AND job_inventory_id='$job_inventory_id'";

      $result = $xoopsDB->queryF($sql);

      if (!$result) {
        $feedback .= ' JOB skill delete FAILED ';
        echo $xoopsDB->error();
      } else {
        $feedback .= ' '._XF_PEO_JOBSKILLDELETED.' ';
      }
    } else {
      $feedback .= ' JOB skill delete failed - wrong project_id ';
    }
  }

  /*
    Fill in the info to create a job
  */

  people_header($group_id, $job_id);
  echo "<H4>"._XF_PEO_EDITJOBFORPROJECT."</H4>";
	
  //for security, include group_id
  $sql = "SELECT * FROM ".$xoopsDB->prefix("xf_people_job")." WHERE job_id='$job_id' AND group_id='$group_id'";
  $result = $xoopsDB->query($sql);
	
  if (!$result) {
    echo $xoopsDB->error();
    $feedback .= ' POSTING fetch FAILED ';
    echo '<b>'._XF_PEO_NOSUCHPOSTING.'</b>';
  } else {
  // TODO: Add People Job calculations to the update.php cronjob (	All postings are automatically closed after two weeks. )
    echo '
        <P>'._XF_PEO_EDITJOBSKILLINFO.'
	      <P>'._XF_PEO_POSTINGSCLOSEAUTO.'
	      <P>
	      <FORM ACTION="'.$PHP_SELF.'" METHOD="POST">
	      <INPUT TYPE="HIDDEN" NAME="group_id" VALUE="'.$group_id.'">
	      <INPUT TYPE="HIDDEN" NAME="job_id" VALUE="'.$job_id.'">
	      <B>'._XF_PEO_CATEGORY.':</B><BR>
	      '. people_job_category_box('category_id',unofficial_getDBResult($result,0,'category_id')) .'
	      <P>
	      <B>'._XF_PEO_STATUS.':</B><BR>
	      '. people_job_status_box('status_id',unofficial_getDBResult($result,0,'status_id')) .'
	      <P>
	      <B>'._XF_PEO_SHORTDESCRIPTION.':</B><BR>
	      <INPUT TYPE="TEXT" NAME="title" VALUE="'. $ts->makeTboxData4Show(unofficial_getDBResult($result,0,'title')) .'" SIZE="40" MAXLENGTH="60">
	      <P>
	      <B>'._XF_PEO_LONGDESCRIPTION.':</B><BR>
	      <TEXTAREA NAME="description" ROWS="10" COLS="60" WRAP="SOFT">'. $ts->makeTareaData4Savehow(unofficial_getDBResult($result,0,'description')) .'</TEXTAREA>
	      <P>
	      <INPUT TYPE="SUBMIT" NAME="update_job" VALUE="'._XF_PEO_UPDATEDESCRIPTIONS.'">
	      </FORM>';

        //now show the list of desired skills
	  echo '<P>'.people_edit_job_inventory($job_id,$group_id);
	  echo '<P><FORM ACTION="'.XOOPS_URL.'/xf/people/" METHOD="POST">
		         <INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="'._XF_PEO_FINISHED.'"></FORM>';
	}

  people_footer();

} else {

  redirect_header($GLOBALS["HTTP_REFERER"],4,"ERROR<br />No Group!");
  exit;

}
?>
