<?php
/**
 * SourceForge Jobs (aka Help Wanted) Board
 *
 * Job/People finder
 *
 * SourceForge: Breaking Down the Barriers to Open Source Development
 * Copyright 1999-2001 (c) VA Linux Systems
 * http://sourceforge.net
 *
 * @athor		Tim Perdue <tperdue@valinux.com>
 * @version		$Id: people_utils.php,v 1.4 2002/05/30 22:06:32 arjenvanefferen Exp $
 *
 */

function people_header($group_id, $job_id) {
  global $feedback, $xoopsTheme;

  include (XOOPS_ROOT_PATH."/header.php");
  OpenTable();

	if ($group_id) {
    $group =& group_get_object($group_id);

    echo "<b>"._XF_G_PROJECT.": ".$group->getPublicName()."</b><br /><br />";
    echo "<B style='font-size:16px;align:left;'>".sprintf(_XF_PEO_PROJECTHELPFOR,$group->getPublicName())."</B><br />";
    project_tabs ('people', $group_id);
	} else {
	
    echo "<H4>XoopsForge "._XF_PEO_HELPREQUESTS."</H4>";
		
	}

	if ($group_id && $job_id) {
		echo '<b><A HREF="'.XOOPS_URL.'/xf/people/editjob.php?group_id='.$group_id.'&job_id='.$job_id.'">'._XF_PEO_EDITJOB.'</A></b>';
	}
  echo '<P>'.$feedback.'<br />';
}

function people_footer() {
  CloseTable();
  include (XOOPS_ROOT_PATH."/footer.php");
}


function people_skill_box($name='skill_id',$checked='xyxy') {
	global $PEOPLE_SKILL, $xoopsDB;

	if (!$PEOPLE_SKILL) {
		//will be used many times potentially on a single page
		$sql = "SELECT * FROM ".$xoopsDB->prefix("xf_people_skill")." ORDER BY name ASC";
		$PEOPLE_SKILL = $xoopsDB->query($sql);
	}
	return html_build_select_box ($PEOPLE_SKILL, $name, $checked);
}

function people_skill_level_box($name='skill_level_id',$checked='xyxy') {
	global $PEOPLE_SKILL_LEVEL, $xoopsDB;

	if (!$PEOPLE_SKILL_LEVEL) {
		//will be used many times potentially on a single page
		$sql = "SELECT * FROM ".$xoopsDB->prefix("xf_people_skill_level");
		$PEOPLE_SKILL_LEVEL = $xoopsDB->query($sql);
	}
	return html_build_select_box ($PEOPLE_SKILL_LEVEL,$name,$checked);
}

function people_skill_year_box($name='skill_year_id',$checked='xyxy') {
	global $PEOPLE_SKILL_YEAR, $xoopsDB;

	if (!$PEOPLE_SKILL_YEAR) {
		//will be used many times potentially on a single page
		$sql = "SELECT * FROM ".$xoopsDB->prefix("xf_people_skill_year");
		$PEOPLE_SKILL_YEAR = $xoopsDB->query($sql);
	}
	return html_build_select_box ($PEOPLE_SKILL_YEAR,$name,$checked);
}

function people_job_status_box($name='status_id',$checked='xyxy') {
	global $xoopsDB;

	$sql = "SELECT * FROM ".$xoopsDB->prefix("xf_people_job_status");
	$result = $xoopsDB->query($sql);

	return html_build_select_box ($result,$name,$checked);
}

function people_job_category_box($name='category_id',$checked='xyxy') {
	global $xoopsDB;

	$sql = "SELECT category_id,name FROM ".$xoopsDB->prefix("xf_people_job_category")." WHERE private_flag=0";
	$result = $xoopsDB->query($sql);

	return html_build_select_box ($result,$name,$checked);
}

function people_add_to_skill_inventory($skill_id,$skill_level_id,$skill_year_id) {
	global $feedback, $xoopsDB, $xoopsUser;

	if ($xoopsUser) {
		//check if they've already added this skill
		$sql = "SELECT * "
		      ."FROM ".$xoopsDB->prefix("xf_people_skill_inventory")." "
					."WHERE user_id='".$xoopsUser->getVar("uid")."' "
					."AND skill_id='$skill_id'";

		$result = $xoopsDB->query($sql);

		if (!$result || $xoopsDB->getRowsNum($result) < 1) {
			//skill not already in inventory
			$sql = "INSERT INTO ".$xoopsDB->prefix("xf_people_skill_inventory")." (user_id,skill_id,skill_level_id,skill_year_id) "
			      ."VALUES ('".$xoopsUser->getVar("uid")."','$skill_id','$skill_level_id','$skill_year_id')";

			$result = $xoopsDB->queryF($sql);

			if (!$result) {
				$feedback .= ' ERROR inserting into skill inventory ';
				echo $xoopsDB->error();
			} else {
				$feedback .= ' '._XF_PEO_ADDEDTOSKILLINVENTORY.' ';
			}
		} else {
			$feedback .= ' ERROR - '._XF_PEO_SKILLALREADYININVENTORY.' ';
		}
	} else {
		echo '<H4>'._XF_PEO_MUSTBELOGGEDIN.'</H4>';
	}
}

function people_show_skill_inventory($user_id) {
  global $xoopsDB;

	$sql = "SELECT ps.name AS skill_name, psl.name AS level_name, psy.name AS year_name "
	      ."FROM ".$xoopsDB->prefix("xf_people_skill_year")." psy,".$xoopsDB->prefix("xf_people_skill_level")." psl,".$xoopsDB->prefix("xf_people_skill")." ps,".$xoopsDB->prefix("xf_people_skill_inventory")." psi "
				."WHERE psy.skill_year_id=psi.skill_year_id "
				."AND psl.skill_level_id=psi.skill_level_id "
				."AND ps.skill_id=psi.skill_id "
				."AND psi.user_id='$user_id'";

  $result = $xoopsDB->query($sql);

	echo "<TABLE cellspacing='1' cellpadding='5' width='100%' border='0'>"
      ."<TR class='bg2'>"
      ."<TD align='center'><b>"._XF_PEO_SKILL."</b></td>"
      ."<td align='center'><b>"._XF_PEO_LEVEL."</b></td>"
      ."<TD align='center'><b>"._XF_PEO_EXPERIENCE."</b></td>"
      ."</TR>";

	$rows = $xoopsDB->getRowsNum($result);
	if (!$result || $rows < 1) {
		echo '<H4>'._XF_PEO_NOSKILLINVENTORYSETUP.'</H4>';
		echo $xoopsDB->error();
	} else {
		for ($i=0; $i < $rows; $i++) {
			echo '
			<TR class="'.($i%2!=0?'bg2':'bg3').'">
			<TD>'.unofficial_getDBResult($result,$i,'skill_name').'</TD>
			<TD>'.unofficial_getDBResult($result,$i,'level_name').'</TD>
			<TD>'.unofficial_getDBResult($result,$i,'year_name').'</TD></TR>';

		}
	}
	echo '</TABLE>';
}

function people_edit_skill_inventory($user_id) {
	global $PHP_SELF, $xoopsDB;

	$sql="SELECT * FROM ".$xoopsDB->prefix("xf_people_skill_inventory")." WHERE user_id='$user_id'";

	$result = $xoopsDB->query($sql);

	echo "<TABLE cellspacing='1' cellpadding='5' width='100%' border='0'>"
      ."<TR class='bg2'>"
      ."<TD align='center'><b>"._XF_PEO_SKILL."</b></td>"
      ."<td align='center'><b>"._XF_PEO_LEVEL."</b></td>"
      ."<TD align='center'><b>"._XF_PEO_EXPERIENCE."</b></td>"
      ."<TD align='center'><b>"._XF_PEO_ACTION."</b></td>"
      ."</TR>";

	$rows = $xoopsDB->getRowsNum($result);
	
	if (!$result || $rows < 1) {
		echo '
			<TR><TD COLSPAN="4"><H4>'._XF_PEO_NOSKILLINVENTORYSETUP.'</H4></TD></TR>';
		echo $xoopsDB->error();
	} else {
		for ($i=0; $i < $rows; $i++) {
			echo '
			<FORM ACTION="'.$PHP_SELF.'" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="skill_inventory_id" VALUE="'.unofficial_getDBResult($result,$i,'skill_inventory_id').'">
			<TR class="'.($i%2!=0?'bg2':'bg3').'">
				<TD><FONT SIZE="-1">'. people_get_skill_name(unofficial_getDBResult($result,$i,'skill_id')) .'</TD>
				<TD><FONT SIZE="-1">'. people_skill_level_box('skill_level_id',unofficial_getDBResult($result,$i,'skill_level_id')). '</TD>
				<TD><FONT SIZE="-1">'. people_skill_year_box('skill_year_id',unofficial_getDBResult($result,$i,'skill_year_id')). '</TD>
				<TD NOWRAP><FONT SIZE="-1"><INPUT TYPE="SUBMIT" NAME="update_skill_inventory" VALUE="Update"> &nbsp;
					<INPUT TYPE="SUBMIT" NAME="delete_from_skill_inventory" VALUE="'._XF_G_DELETE.'"></TD>
				</TR></FORM>';
		}

	}
	//add a new skill
	$i++; //for row coloring

	echo '
	<TR><TD COLSPAN="4"><H3>'._XF_PEO_ADDANEWSKILL.'</H3></TD></TR>
	<FORM ACTION="'.$PHP_SELF.'" METHOD="POST">
	<TR class="'.($i%2!=0?'bg2':'bg3').'">
		<TD><FONT SIZE="-1">'. people_skill_box('skill_id'). '</TD>
		<TD><FONT SIZE="-1">'. people_skill_level_box('skill_level_id'). '</TD>
		<TD><FONT SIZE="-1">'. people_skill_year_box('skill_year_id'). '</TD>
		<TD NOWRAP><FONT SIZE="-1"><INPUT TYPE="SUBMIT" NAME="add_to_skill_inventory" VALUE="'._XF_PEO_ADDSKILL.'"></TD>
	</TR></FORM>';

	echo '</TABLE>';
}


function people_add_to_job_inventory($job_id,$skill_id,$skill_level_id,$skill_year_id) {
  global $feedback, $xoopsUser, $xoopsDB;

  if ($xoopsUser) {
    //check if they've already added this skill
    $sql = "SELECT * FROM ".$xoopsDB->prefix("xf_people_job_inventory")." WHERE job_id='$job_id' AND skill_id='$skill_id'";

    $result = $xoopsDB->query($sql);
    if (!$result || $xoopsDB->getRowsNum($result) < 1) {
      //skill isn't already in this inventory
      $sql = "INSERT INTO ".$xoopsDB->prefix("xf_people_job_inventory")." (job_id,skill_id,skill_level_id,skill_year_id) "
            ."VALUES ('$job_id','$skill_id','$skill_level_id','$skill_year_id')";

      $result = $xoopsDB->queryF($sql);

      if (!$result) {
        $feedback .= ' ERROR inserting into skill inventory ';
        echo $xoopsDB->error();
      } else {
        $feedback .= ' '._XF_PEO_ADDEDTOSKILLINVENTORY.' ';
      }
    } else {
      $feedback .= ' ERROR - '._XF_PEO_SKILLALREADYININVENTORY.' ';
    }
  } else {
    echo '<H4>'._XF_PEO_MUSTBELOGGEDIN.'</H4>';
  }

}

function people_show_job_inventory($job_id) {
  global $xoopsDB;

	$sql = "SELECT ps.name AS skill_name, psl.name AS level_name, psy.name AS year_name "
        ."FROM ".$xoopsDB->prefix("xf_people_skill_year")." psy,".$xoopsDB->prefix("xf_people_skill_level")." psl,".$xoopsDB->prefix("xf_people_skill")." ps,".$xoopsDB->prefix("xf_people_job_inventory")." pji "
        ."WHERE psy.skill_year_id=pji.skill_year_id "
        ."AND psl.skill_level_id=pji.skill_level_id "
        ."AND ps.skill_id=pji.skill_id "
        ."AND pji.job_id='$job_id'";

	$result = $xoopsDB->query($sql);

	echo "<TABLE cellspacing='1' cellpadding='5' width='100%' border='0'>"
      ."<TR class='bg2'>"
      ."<TD align='center'><b>"._XF_PEO_SKILL."</b></td>"
      ."<td align='center'><b>"._XF_PEO_LEVEL."</b></td>"
      ."<TD align='center'><b>"._XF_PEO_EXPERIENCE."</b></td>"
      ."</TR>";

	$rows = $xoopsDB->getRowsNum($result);
	if (!$result || $rows < 1) {
		echo '<H4>No Skill Inventory Set Up</H4>';
		echo $xoopsDB->error();
	} else {
		for ($i=0; $i < $rows; $i++) {
			echo '<TR class="'.($i%2!=0?'bg2':'bg3').'">
            <TD>'.unofficial_getDBResult($result,$i,'skill_name').'</TD>
            <TD>'.unofficial_getDBResult($result,$i,'level_name').'</TD>
            <TD>'.unofficial_getDBResult($result,$i,'year_name').'</TD></TR>';

		}
	}
	echo '</TABLE>';
}

function people_verify_job_group($job_id,$group_id) {
  global $xoopsDB;

	$sql = "SELECT job_id FROM ".$xoopsDB->prefix("xf_people_job")." WHERE job_id='$job_id' AND group_id='$group_id'";

	$result = $xoopsDB->query($sql);

	if (!$result || $xoopsDB->getRowsNum($result) < 1) {
		return false;
	} else {
		return true;
	}
}

function people_get_skill_name($skill_id) {
  global $xoopsDB;

	$sql="SELECT name FROM ".$xoopsDB->prefix("xf_people_skill")." WHERE skill_id='$skill_id'";
	$result = $xoopsDB->query($sql);
	if (!$result || $xoopsDB->getRowsNum($result) < 1) {
		return 'Invalid ID';
	} else {
		return unofficial_getDBResult($result,0,'name');
	}
}

function people_get_category_name($category_id) {
	$sql="SELECT name FROM people_job_category WHERE category_id='$category_id'";
	$result=db_query($sql);
	if (!$result || db_numrows($result) < 1) {
		return 'Invalid ID';
	} else {
		return db_result($result,0,'name');
	}
}

function people_edit_job_inventory($job_id,$group_id) {
	global $PHP_SELF, $xoopsDB;

	$sql = "SELECT * FROM ".$xoopsDB->prefix("xf_people_job_inventory")." WHERE job_id='$job_id'";

	$result = $xoopsDB->query($sql);

	echo "<TABLE cellspacing='1' cellpadding='5' width='100%' border='0'>"
      ."<TR class='bg2'>"
      ."<TD align='center'><b>"._XF_PEO_SKILL."</b></td>"
      ."<td align='center'><b>"._XF_PEO_LEVEL."</b></td>"
      ."<TD align='center'><b>"._XF_PEO_EXPERIENCE."</b></td>"
      ."<TD align='center'><b>"._XF_PEO_ACTION."</b></td>"
      ."</TR>";

	$rows = $xoopsDB->getRowsNum($result);
	if (!$result || $rows < 1) {
    echo '<TR><TD COLSPAN="4"><H4>'._XF_PEO_NOSKILLINVENTORYSETUP.'</H4></TD></TR>';
    echo $xoopsDB->error();
	} else {
    for ($i=0; $i < $rows; $i++) {
    echo '
    <FORM ACTION="'.$PHP_SELF.'" METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="job_inventory_id" VALUE="'. unofficial_getDBResult($result,$i,'job_inventory_id') .'">
		<INPUT TYPE="HIDDEN" NAME="job_id" VALUE="'. unofficial_getDBResult($result,$i,'job_id') .'">
		<INPUT TYPE="HIDDEN" NAME="group_id" VALUE="'.$group_id.'">
		<TR class="'.($i%2!=0?'bg2':'bg3').'">
		<TD><FONT SIZE="-1">'. people_get_skill_name(unofficial_getDBResult($result,$i,'skill_id')) . '</TD>
		<TD><FONT SIZE="-1">'. people_skill_level_box('skill_level_id',unofficial_getDBResult($result,$i,'skill_level_id')). '</TD>
	        <TD><FONT SIZE="-1">'. people_skill_year_box('skill_year_id',unofficial_getDBResult($result,$i,'skill_year_id')). '</TD>
		<TD NOWRAP><FONT SIZE="-1">
		<INPUT TYPE="SUBMIT" NAME="update_job_inventory" VALUE="'._XF_G_UPDATE.'"> &nbsp;
		<INPUT TYPE="SUBMIT" NAME="delete_from_job_inventory" VALUE="'._XF_G_DELETE.'"></TD>
		</TR></FORM>';
	  }
	}
	//add a new skill
	$i++; //for row coloring

	echo '
	<TR><TD COLSPAN="4"><H3>'._XF_PEO_ADDANEWSKILL.'</H3></TD></TR>
	<FORM ACTION="'.$PHP_SELF.'" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="job_id" VALUE="'. $job_id .'">
	<INPUT TYPE="HIDDEN" NAME="group_id" VALUE="'.$group_id.'">
	<TR BGCOLOR="'. html_get_alt_row_color($i) .'">
	<TD><FONT SIZE="-1">'. people_skill_box('skill_id'). '</TD>
	<TD><FONT SIZE="-1">'. people_skill_level_box('skill_level_id'). '</TD>
	<TD><FONT SIZE="-1">'. people_skill_year_box('skill_year_id'). '</TD>
	<TD NOWRAP><FONT SIZE="-1">
	<INPUT TYPE="SUBMIT" NAME="add_to_job_inventory" VALUE="'._XF_PEO_ADDSKILL.'"></TD>
	</TR></FORM>';

	echo '</TABLE>';
}

function people_show_category_table() {

  global $xoopsDB;

	$return .= "<TABLE cellspacing='1' cellpadding='5' width='100%' border='0'>"
            ."<TR class='bg2'>"
            ."<TD align='center'><b>"._XF_PEO_CATEGORY."</b></td>"
            ."</TR>";

	$sql = "SELECT pjc.category_id, pjc.name, COUNT(pj.category_id) AS total "
	      ."FROM ".$xoopsDB->prefix("xf_people_job_category")." pjc "
				."LEFT JOIN ".$xoopsDB->prefix("xf_people_job")." pj "
				."ON pjc.category_id=pj.category_id "
				."WHERE pjc.private_flag=0 "
				."AND (pj.status_id=1 OR pj.status_id IS NULL) "
				."GROUP BY pjc.category_id, pjc.name";

	$result = $xoopsDB->query($sql);
	$rows = $xoopsDB->getRowsNum($result);
	if (!$result || $rows < 1) {
		$return .= '<TR><TD><H4>'._XF_PEO_NOCATEGORIESFOUND.'</H4></TD></TR>';
	} else {
		echo $xoopsDB->error();
		for ($i=0; $i<$rows; $i++) {
			$return .= '<TR class="'.($i%2!=0?'bg2':'bg3').'"><TD><A HREF="'.XOOPS_URL.'/xf/people/?category_id='
			          .unofficial_getDBResult($result,$i,'category_id') .'">'
								.unofficial_getDBResult($result,$i,'name').'</A> ('.unofficial_getDBResult($result,$i,'total') .')</TD></TR>';
		}
	}
	$return .= '</TABLE>';
	return $return;
}

function people_show_project_jobs($group_id) {
  global $xoopsDB;

	//show open jobs for this project
	$sql = "SELECT pj.group_id,pj.job_id,g.group_name,g.unix_group_name,pj.title,pj.date,pjc.name AS category_name "
		    ."FROM ".$xoopsDB->prefix("xf_people_job")." pj,".$xoopsDB->prefix("xf_people_job_category")." pjc,".$xoopsDB->prefix("xf_groups")." g "
		    ."WHERE pj.group_id='$group_id' "
				."AND pj.group_id=g.group_id "
				."AND pj.category_id=pjc.category_id "
				."AND pj.status_id=1 "
				."ORDER BY date DESC";

	$result = $xoopsDB->query($sql);

	return people_show_job_list($result);
}

function people_show_category_jobs($category_id) {
  global $xoopsDB;

	//show open jobs for this category
	$sql = "SELECT pj.group_id,pj.job_id,g.group_name,g.unix_group_name,pj.title,pj.date,pjc.name AS category_name "
		    ."FROM ".$xoopsDB->prefix("xf_people_job")." pj,".$xoopsDB->prefix("xf_people_job_category")." pjc,".$xoopsDB->prefix("xf_groups")." g "
				."WHERE pj.category_id='$category_id' "
				."AND pj.group_id=g.group_id "
				."AND pj.category_id=pjc.category_id "
				."AND pj.status_id=1 "
				."ORDER BY date DESC";

	$result = $xoopsDB->query($sql);

	return people_show_job_list($result);
}

function people_show_job_list($result) {
  global $xoopsDB, $sys_datefmt;
	//takes a result set from a query and shows the jobs

	//query must contain 'group_id', 'job_id', 'title', 'category_name' and 'status_name'
  $return .= "
		<TABLE cellspacing='1' cellpadding='5' width='100%' border='0'>
		<TR class='bg2'>
		<TD align='center'><b>"._XF_PEO_TITLE."</b></td>
		<td align='center'><b>"._XF_PEO_CATEGORY."</b></td>
		<TD align='center'><b>"._XF_PEO_DATEOPENED."</b></td>
		<TD align='center'><b>"._XF_G_PROJECT."</b></td>
		</TR>";

	$rows = $xoopsDB->getRowsNum($result);
	if ($rows < 1) {
		$return .= '<TR><TD COLSPAN="3"><H4>'._XF_PEO_NONEFOUND.'</H4>'. $xoopsDB->error() .'</TD></TR>';
	} else {
		for ($i=0; $i < $rows; $i++) {
      $group_id = unofficial_getDBResult($result,$i,'group_id');
      $return .= "<TR class='".($i%2!=0?'bg2':'bg3')."'>"
                ."<TD><A HREF='".XOOPS_URL."/xf/people/viewjob.php?group_id="
                .$group_id."&job_id="
                .unofficial_getDBResult($result,$i,'job_id')."'>"
                .unofficial_getDBResult($result,$i,'title')."</A></TD><TD>"
                .unofficial_getDBResult($result,$i,'category_name')."</TD><TD>"
                .date($sys_datefmt, unofficial_getDBResult($result,$i,'date'))
                ."</TD><TD><a href='".XOOPS_URL."/xf/project/?".unofficial_getDBResult($result,$i,'unix_group_name')."'>"
                .unofficial_getDBResult($result,$i,'group_name')."</a></TD></TR>";
		}
	}

	$return .= "</TABLE>";

	return $return;
}

?>
