<?php
/**
  *
  * SourceForge Project/Task Manager (PM)
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: pm_utils.php,v 1.4 2002/06/07 09:17:34 arjenvanefferen Exp $
  *
  */


/*

	Project/Task Manager
	By Tim Perdue, Sourceforge, 11/99
	Heavy rewrite by Tim Perdue April 2000

*/

function pm_header($group, $title=_XF_PM_TASKS, $group_project_id) {

  global $xoopsUser, $feedback, $xoopsTheme;
//	global $group_id,$is_pm_page,$words,$group_project_id,$DOCUMENT_ROOT,$order;


  include (XOOPS_ROOT_PATH."/header.php");
  OpenTable();

  if ($group) {
    echo "<b>"._XF_G_PROJECT.": ".$group->getPublicName()."</b><br /><br />";
    echo "<B style='font-size:16px;align:left;'>$title</B><br />";
    project_tabs ('pm', $group->getID());

    if (!$group->isProject()) {
      echo _XF_PM_ONLYPROJECTSCANUSE;

      CloseTable();
      include (XOOPS_ROOT_PATH."/footer.php");
      exit;
    }

    if (!$group->usesPm()) {
      echo ''._XF_PM_PROJECTSTURNEDOFF;

      CloseTable();
      include (XOOPS_ROOT_PATH."/footer.php");
      exit;
    }

    echo "<P><B>";

    echo "<A HREF='".XOOPS_URL."/xf/pm/?group_id=".$group->getID()."'>"._XF_PM_SUBPROJECTLIST."</A>";
    $need_bar = 1;

    if ($group_project_id) {
      if ( $xoopsUser ) {
        if ($need_bar)
          echo ' | ';

        echo "<A HREF='".XOOPS_URL."/xf/pm/task.php?group_id=".$group->getID()."&group_project_id=$group_project_id&func=addtask'>"._XF_PM_ADDTASK."</A>";
        echo " | <A HREF='".XOOPS_URL."/xf/pm/task.php?group_id=".$group->getID()."&group_project_id=$group_project_id&func=browse&set=my'>"._XF_PM_MYTASKS."</A>";

        $need_bar = 1;
      }
      if ($need_bar)
        echo ' | ';

      echo "<A HREF='".XOOPS_URL."/xf/pm/task.php?group_id=".$group->getID()."&group_project_id=$group_project_id&func=browse&set=open'>"._XF_PM_BROWSEOPENTASKS."</A>";

      $need_bar = 1;
    }

    if ($need_bar)
      echo ' | ';

    echo "<A HREF='".XOOPS_URL."/xf/pm/admin/?group_id=".$group->getID()."'>"._XF_G_ADMIN."</A>";
    echo "</B>";
    echo "<p><font color='red'>".$feedback."</font></p>";
  }
  else
  {
    echo 'Error<br />Invalid Group';

    CloseTable();
    include (XOOPS_ROOT_PATH."/footer.php");
    exit;
  }
}

function pm_footer() {
  CloseTable();
  include (XOOPS_ROOT_PATH."/footer.php");
}

function pm_status_box($name='status_id',$checked='xyxy',$text_100=_XF_G_NONE) {
  $result = pm_data_get_statuses();
  return html_build_select_box($result,$name,$checked,true,$text_100);
}

function pm_tech_select_box($name='assigned_to',$group_id=false,$checked='xzxz') {
	if (!$group_id) {
		return 'ERROR - no group_id';
	} else {
		$result=pm_data_get_technicians ($group_id);
		return html_build_select_box($result,$name,$checked);
	}
}

function pm_multiple_task_depend_box ($name='dependent_on[]',$group_project_id=false,$project_task_id=false) {
	if (!$group_project_id) {
		return 'ERROR - no group_project_id';
	} else {
		$result = pm_data_get_tasks ($group_project_id);
		if ($project_task_id) {
			$result=pm_data_get_other_tasks ($group_project_id,$project_task_id);
			//get the data so we can mark items as SELECTED
			$result2=pm_data_get_dependent_tasks ($project_task_id);
			return html_build_multiple_select_box ($result,$name,util_result_column_to_array($result2));
		} else {
			return html_build_multiple_select_box ($result,$name,array());
		}
	}
}

function pm_show_subprojects_box($name='group_project_id',$group_id=false,$group_project_id=false) {
  if (!$group_id || !$group_project_id) {
    return 'ERROR - no group_id defined';
  } else {
    $result = pm_data_get_subprojects($group_id);
    return html_build_select_box($result,$name,$group_project_id,false);
  }
}

function pm_multiple_assigned_box ($name='assigned_to[]',$group_id=false,$project_task_id=false) {
	if (!$group_id) {
		return 'ERROR - no group_id';
	} else {
		$result=pm_data_get_technicians ($group_id);
		if ($project_task_id) {
			//get the data so we can mark items as SELECTED
			$result2=pm_data_get_assigned_to ($project_task_id);
			return html_build_multiple_select_box ($result,$name,util_result_column_to_array($result2));
		} else {
			return html_build_multiple_select_box ($result,$name,array());
		}
	}
}

function pm_show_percent_complete_box($name='percent_complete',$selected=0) {
	echo '
		<select name="'.$name.'">';
	echo '
		<option value="0">'._XF_PM_NOTSTARTED;
	for ($i=5; $i<101; $i+=5) {
		echo '
			<option value="'.$i.'"';
		if ($i==$selected) {
			echo ' SELECTED';
		}
		echo '>'.$i.'%';
	}
	echo '
		</select>';
}

function pm_show_month_box($name,$select_month=0) {

	echo '
		<select name="'.$name.'" size="1">';
	$monthlist = array('1'=>_XF_G_JANUARY,
	                   '2'=>_XF_G_FEBRUARY,
			 '3'=>_XF_G_MARCH,
			 '4'=>_XF_G_APRIL,
			 '5'=>_XF_G_MAY,
			 '6'=>_XF_G_JUNE,
			 '7'=>_XF_G_JULY,
			 '8'=>_XF_G_AUGUST,
			 '9'=>_XF_G_SEPTEMBER,
			 '10'=>_XF_G_OCTOBER,
			 '11'=>_XF_G_NOVEMBER,
			 '12'=>_XF_G_DECEMBER);

	for ($i=1; $i<=count($monthlist); $i++) {
		if ($i == $select_month) {
			echo '
				<option selected value="'.$i.'">'.$monthlist[$i];
		} else {
			echo '
				<option value="'.$i.'">'.$monthlist[$i];
		}
	}
	echo '
		</SELECT>';

}

function pm_show_day_box($name,$day=1) {

	echo '
		<select name="'.$name.'" size="1">';
	for ($i=1; $i<=31; $i++) {
		if ($i == $day) {
			echo '
				<option selected value="'.$i.'">'.$i;
		} else {
			echo '
				<option value="'.$i.'">'.$i;
		}
	}
	echo '
		</select>';

}

function pm_show_year_box($name,$year=1) {

	echo '
		<select name="'.$name.'" size="1">';
	for ($i=1999; $i<=2013; $i++) {
		if ($i == $year) {
			echo '
				<option selected value="'.$i.'">'.$i;
		} else {
			echo '
				<option value="'.$i.'">'.$i;
		}
	}
	echo '
		</select>';

}

function pm_show_tasklist ($result,$offset,$set='open') {
  global $sys_datefmt,$group_id,$group_project_id,$PHP_SELF, $xoopsDB, $ts;
  /*
    Accepts a result set from the bugs table. Should include all columns from
    the table, and it should be joined to USER to get the user_name.
  */

  $rows = $xoopsDB->getRowsNum($result);

  $url = XOOPS_URL."/xf/pm/task.php?group_id=$group_id&group_project_id=$group_project_id&func=browse&set=$set&order=";

  echo "<table border='0' width='100%'>"
      ."<tr class='bg2'>"
      ."<td><b><a href='".$url."project_task_id'>"._XF_PM_TASKID."</a></b></td>"
      ."<td><b><a href='".$url."summary'>"._XF_G_SUMMARY."</a></b></td>"
      ."<td><b><a href='".$url."start_date'>"._XF_PM_STARTDATE."</a></b></td>"
      ."<td><b><a href='".$url."end_date'>"._XF_PM_ENDDATE."</a></b></td>"
      ."<td><b><a href='".$url."percent_complete'>"._XF_PM_PERCENTCOMPLETE."</a></b></td>"
      ."</tr>";

  $now=time();

  for ($i=0; $i < $rows; $i++) {
    echo '<TR BGCOLOR="'.get_priority_color(unofficial_getDBResult($result, $i, 'priority')).'">'
        .'<TD><A HREF="'.$PHP_SELF.'?func=detailtask'
        .'&project_task_id='.unofficial_getDBResult($result, $i, 'project_task_id')
        .'&group_id='.$group_id
        .'&group_project_id='.unofficial_getDBResult($result, $i, 'group_project_id').'">'
        .unofficial_getDBResult($result, $i, 'project_task_id').'</A></TD>'
        .'<TD>'.$ts->makeTboxData4Show(unofficial_getDBResult($result, $i, 'summary')).'</TD>'
        .'<TD>'.date('Y-m-d',unofficial_getDBResult($result, $i, 'start_date')).'</TD>'
        .'<TD>'. (($now>unofficial_getDBResult($result, $i, 'end_date'))?'<B>* ':'&nbsp; ') . date('Y-m-d',unofficial_getDBResult($result, $i, 'end_date')).'</TD>'
        .'<TD>';
    $pc = unofficial_getDBResult($result, $i, 'percent_complete');
    for ($k = 5; $k <= 100; $k += 5) {
      if ($k <= $pc)
        echo '<img src="'.XOOPS_URL.'/xf/images/pb.gif" width="6" height="10" alt="'.$pc.'% complete">';
      else
        echo '<img src="'.XOOPS_URL.'/xf/images/pb_e.gif" width="6" height="10" alt="'.$pc.'% complete">';
    }
    echo '&nbsp;&nbsp;'.$pc.'%</TD></TR>';
  }
  /*
    Show extra rows for <-- Prev / Next -->
  */
  echo '<TR><TD COLSPAN="2">';
  if ($offset > 0) {
    echo '<A HREF="'.$PHP_SELF.'?func=browse&group_project_id='
        .$group_project_id.'&set='.$set.'&group_id='.$group_id.'&offset='.($offset-50).'"><B><-- '._XF_G_PREVIOUS.' 50</B></A>';
  } else {
    echo '&nbsp;';
  }
  echo '</TD><TD>&nbsp;</TD><TD COLSPAN="2">';

  if ($rows==50) {
    echo '<A HREF="'.$PHP_SELF.'?func=browse&group_project_id='
        .$group_project_id.'&set='.$set.'&group_id='.$group_id.'&offset='.($offset+50).'"><B>'._XF_G_NEXT.' 50 --></B></A>';
  } else {
    echo '&nbsp;';
  }
  echo '</TD></TR></TABLE>';
}

function pm_show_dependent_tasks ($project_task_id,$group_id,$group_project_id) {
  global $xoopsDB;

  $sql = "SELECT pt.project_task_id,pt.summary "
        ."FROM ".$xoopsDB->prefix("xf_project_task")." pt,".$xoopsDB->prefix("xf_project_dependencies")." pd "
        ."WHERE pt.project_task_id=pd.project_task_id "
        ."AND pd.is_dependent_on_task_id='$project_task_id'";

  $result = $xoopsDB->query($sql);
  $rows = $xoopsDB->getRowsNum($result);

  if ($rows > 0) {
    echo '<H4>'._XF_PM_TASKSTHATDEPEND.'</H4>
          <P>';

    echo "<table border='0' width='100%'>"
        ."<tr class='bg2'>"
        ."<td><b>"._XF_PM_TASKID."</b></td>"
        ."<td><b>"._XF_G_SUMMARY."</b></td>"
        ."</tr>";

    for ($i=0; $i < $rows; $i++) {
      echo '<TR class="'.($j%2>0?'bg1':'bg3').'">
            <TD><A HREF="'.XOOPS_URL.'/xf/pm/task.php?func=detailtask&project_task_id='
           .unofficial_getDBResult($result, $i, 'project_task_id')
           .'&group_id='.$group_id
           .'&group_project_id='.$group_project_id.'">'
           .unofficial_getDBResult($result, $i, 'project_task_id').'</TD>
            <TD>'.$ts->makeTboxData4Show(unofficial_getDBResult($result, $i, 'summary')).'</TD></TR>';
    }
    echo '</TABLE>';
  } else {
    echo '<H4>'._XF_PM_NOTASKSDEPENDENT.'</H4>';
    echo $xoopsDB->error();
  }
}

function pm_show_task_details ($project_task_id) {
  global $sys_datefmt, $xoopsDB, $ts;

  $sql = "SELECT ph.field_name,ph.old_value,ph.date,u.uname "
        ."FROM ".$xoopsDB->prefix("xf_project_history")." ph,".$xoopsDB->prefix("users")." u "
        ."WHERE ph.mod_by=u.uid "
        ."AND ph.field_name='details' "
        ."AND project_task_id='$project_task_id' ORDER BY ph.date DESC";

  $result = $xoopsDB->query($sql);
  $rows = $xoopsDB->getRowsNum($result);

  if ($rows > 0) {
    echo '<H4>'._XF_G_FOLLOWUPS.'</H4>
          <P>';

    echo "<table border='0' width='100%'>"
        ."<tr class='bg2'>"
        ."<td><b>"._XF_G_COMMENT."</b></td>"
        ."<td><b>"._XF_G_DATE."</b></td>"
        ."<td><b>"._XF_G_BY."</b></td>"
        ."</tr>";

    for ($i=0; $i < $rows; $i++) {
      echo '<TR class="'.($j%2>0?'bg1':'bg3').'">
            <TD>'. $ts->makeTboxData4Show(unofficial_getDBResult($result, $i, 'old_value')).'</TD>
            <TD VALIGN="TOP">'.date($sys_datefmt,unofficial_getDBResult($result, $i, 'date')).'</TD>
            <TD VALIGN="TOP">'.unofficial_getDBResult($result, $i, 'uname').'</TD></TR>';
    }
    echo '</TABLE>';
  } else {
    echo '<H4>'._XF_G_NOCOMMENTSADDED.'</H4>';
  }
}

function pm_show_task_history ($project_task_id) {
  global $sys_datefmt, $xoopsDB;

  $sql = "SELECT ph.field_name,ph.old_value,ph.date,u.uname "
        ."FROM ".$xoopsDB->prefix("xf_project_history")." ph,".$xoopsDB->prefix("users")." u "
        ."WHERE ph.mod_by=u.uid "
        ."AND ph.field_name<>'details' "
        ."AND project_task_id='$project_task_id' ORDER BY ph.date DESC";

  $result = $xoopsDB->query($sql);
  $rows = $xoopsDB->getRowsNum($result);

  if ($rows > 0) {
    echo '<H4>'._XF_PM_TASKHISTORY.'</H4>
          <P>';

    echo "<table border='0' width='100%'>"
        ."<tr class='bg2'>"
        ."<td><b>"._XF_G_FIELD."</b></td>"
        ."<td><b>"._XF_G_OLDVALUE."</b></td>"
        ."<td><b>"._XF_G_DATE."</b></td>"
        ."<td><b>"._XF_G_BY."</b></td>"
        ."</tr>";

    for ($i=0; $i < $rows; $i++) {

      $field = unofficial_getDBResult($result, $i, 'field_name');
      echo '<TR class="'.($j%2>0?'bg1':'bg3').'"><TD>'.$field.'</TD><TD>';

      if ($field == 'status_id') {
        echo pm_data_get_status_name(unofficial_getDBResult($result, $i, 'old_value'));
      } else if ($field == 'start_date') {
        echo date('Y-m-d',unofficial_getDBResult($result, $i, 'old_value'));
      } else if ($field == 'end_date') {
        echo date('Y-m-d',unofficial_getDBResult($result, $i, 'old_value'));
      } else {
        echo unofficial_getDBResult($result, $i, 'old_value');
      }

      echo '</TD>
            <TD>'.date($sys_datefmt,unofficial_getDBResult($result, $i, 'date')).'</TD>
            <TD>'.unofficial_getDBResult($result, $i, 'uname').'</TD></TR>';
    }
    echo '</TABLE>';
  } else {
    echo '<H4>'._XF_PM_NOTASKHISTORY.'</H4>';
  }
}
?>