<?php
/**
  *
  * SourceForge Project/Task Manager (PM)
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: task.php,v 1.2 2002/05/29 10:28:44 arjenvanefferen Exp $
  *
  */
include_once ("../../mainfile.php");

require_once(XOOPS_ROOT_PATH."/class/xoopsuser.php");

$langfile="pm.php";
include_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/include/project_summary.php");
require_once(XOOPS_ROOT_PATH."/xf/include/pm/pm_data.php");
require_once(XOOPS_ROOT_PATH."/xf/pm/pm_utils.php");

if ($group_id && $group_project_id) {

  $project = &group_get_object($group_id);

  if ( $xoopsUser ) {
    $perm =& $project->getPermission( $xoopsUser );
  }

  /*
    Verify that this group_project_id falls under this group
  */

  //can this person view these tasks? they may have hacked past the /pm/index.php page
  if ($xoopsUser && ($perm->isMember() || $perm->isSuperUser())) {
    $public_flag='0,1';
  } else {
    $public_flag='1';
  }

  /*
    Verify that this subproject belongs to this project
  */
  $result = $xoopsDB->query("SELECT * FROM ".$xoopsDB->prefix("xf_project_group_list")." "
                           ."WHERE group_project_id='$group_project_id' "
                           ."AND group_id='$group_id' "
                           ."AND is_public IN ($public_flag)");

  if ($xoopsDB->getRowsNum($result) < 1) {
    redirect_header($GLOBALS["HTTP_REFERER"],4,_XF_G_PERMISSIONDENIED."<br />"._XF_PM_SUBPROJECTNOTPROJECT);
    exit;
  }

  if (!$func) {
    $func='browse';
  }

  /*
    Figure out which function we're dealing with here
  */
  switch ($func) {

    case 'addtask' : {
      if ($xoopsUser && ($perm->isPMAdmin() || $perm->isSuperUser())) {
        include 'add_task.php';
      } else {
        redirect_header($GLOBALS["HTTP_REFERER"],4,_XF_G_PERMISSIONDENIED."<br />"._XF_PM_YOUNOTASKMANAGER);
        exit;
      }
    } break;

    case 'postaddtask' : {
      if ($xoopsUser && ($perm->isPMAdmin() || $perm->isSuperUser())) {
        if (pm_data_create_task ($group_project_id,$start_month,$start_day,$start_year,
                                 $end_month,$end_day,$end_year,$summary,$details,$percent_complete,
                                 $priority,$hours,$assigned_to,$dependent_on)) {
          $feedback=""._XF_PM_TASKCREATED;
          include 'browse_task.php';
        } else {
          echo 'ERROR<br />'.$feedback;
          exit;
        }
      } else {
        redirect_header($GLOBALS["HTTP_REFERER"],4,_XF_G_PERMISSIONDENIED."<br />"._XF_G_YOUNOTASKMANAGER);
        exit;
      }
    } break;

    case 'postmodtask' : {
      if ($xoopsUser && ($perm->isPMAdmin() || $perm->isSuperUser())) {
        if (pm_data_update_task ($group_project_id,$project_task_id,$start_month,$start_day,
                                 $start_year,$end_month,$end_day,$end_year,$summary,$details,
                                 $percent_complete,$priority,$hours,$status_id,$assigned_to,
                                 $dependent_on,$new_group_project_id,$group_id)) {
          $feedback=""._XF_PM_TASKUPDATED;
          include 'browse_task.php';
        } else {
          echo 'ERROR<br />'.$feedback;
          exit;
        }
      } else {
        redirect_header($GLOBALS["HTTP_REFERER"],4,_XF_G_PERMISSIONDENIED."<br />"._XF_PM_YOUNOTASKMANAGER);
        exit;
      }
    } break;

    case 'browse' : {
      include 'browse_task.php';
    } break;

    case 'detailtask' : {
      if ($xoopsUser && ($perm->isPMAdmin() || $perm->isSuperUser())) {
        include 'mod_task.php';
      } else {
        include 'detail_task.php';
      }
    } break;
  }
} else {
  redirect_header($GLOBALS["HTTP_REFERER"],4,"Error<br />No Group");
  exit;
}
?>
