<?php
/**
  *
  * Project Admin page to edit project information (like description,
  * active facilities, etc.)
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: editgroupinfo.php,v 1.3 2002/06/07 09:17:34 arjenvanefferen Exp $
  *
  */

include_once ("../../../mainfile.php");

$langfile="project.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/include/vars.php");
require_once(XOOPS_ROOT_PATH."/xf/project/admin/project_admin_utils.php");
require_once(XOOPS_ROOT_PATH."/xf/include/project_summary.php");

project_check_access ($group_id);

// get current information
$group =& group_get_object($group_id);
$perm  =& $group->getPermission( $xoopsUser );

// If this was a submission, make updates

if ($submit) {

	$res = $group->update(
		$xoopsUser,
		$form_group_name,
		$form_homepage,
		$form_shortdesc,
		$use_mail,
		$use_survey,
		$use_forum,
		$use_pm,
		$use_pm_depend,
		$use_cvs,
		$use_news,
		$use_docman,
		$new_task_address,
		$send_all_tasks,
		100 //$logo_image_id
	);

	if (!res) {
		$feedback .= $group->getErrorMessage();
	} else {
		$feedback .= 'Group information updated';
	}
}

include ("../../../header.php");
OpenTable();

echo "<b>"._XF_G_PROJECT.": ".$group->getPublicName()."</b><br /><br />";
echo "<B style='font-size:16px;align:left;'>"._XF_PRJ_EDITGROUPINFO."</B><br />";
project_tabs ('admin', $group_id);
project_admin_header($group_id, $perm->isAdmin());
?>

<P>
<FORM action="<?php echo $PHP_SELF; ?>" method="POST">
<INPUT type="hidden" name="group_id" value="<?php echo $group->getID(); ?>">

<P><?php echo _XF_PRJ_DESCGROUPNAME; ?>:
<BR><INPUT type="text" name="form_group_name" value="<?php echo $group->getPublicName(); ?>">

<P><?php echo _XF_PRJ_SHORTDESCRIPTION255MAX; ?>:
<BR><TEXTAREA cols=80 rows=3 wrap="virtual" name="form_shortdesc">
<?php echo $ts->makeTareaData4Edit($group->getDescription()); ?></TEXTAREA>

<P><?php echo _XF_G_HOMEPAGE; ?>:
<br><tt>http://</tt><INPUT type="text" name="form_homepage" size="40" value="<?php echo $group->getHomePage(); ?>">
<br>

<HR>

<H4><?php echo _XF_PRJ_ACTIVEFEATURES; ?>:</H4>
<P>


<?php

// This function is used to render checkboxes below
function c($v) {
	if ($v) {
		return 'CHECKED';
	} else {
		return '';
	}
}

/*
	Show the options that this project is using
*/
?>
<table>
<?php
/*
<tr>
<td>
 <INPUT TYPE="CHECKBOX" NAME="use_mail" VALUE="1" <?php echo c($group->usesMail()); ?> ><BR>
</td>
<td>
<B>Use Mailing Lists</B>
</td>
</tr>
*/
?>

<tr>
<td>
 <INPUT TYPE="CHECKBOX" NAME="use_survey" VALUE="1" <?php echo c($group->usesSurvey()); ?> ><BR>
</td>
<td>
<B><?php echo _XF_PRJ_USESURVEYS; ?></B>
</td>
</tr>

<tr>
<td>
 <INPUT TYPE="CHECKBOX" NAME="use_forum" VALUE="1" <?php echo c($group->usesForum()); ?>  ><BR>
</td>
<td>
<B><?php echo _XF_PRJ_USEFORUMS; ?></B>
</td>
</tr>

<tr>
<td>
 <INPUT TYPE="CHECKBOX" NAME="use_pm" VALUE="1" <?php echo c($group->usesPM()); ?> ><BR>
</td>
<td>
<B><?php echo _XF_PRJ_USEPROJECTMAN; ?></B>
</td>
</tr>

<tr>
<td>
 <INPUT TYPE="CHECKBOX" NAME="use_pm_depend" VALUE="1" <?php echo c($group->usesPMDependencies()); ?> ><BR>
</td>
<td>
<B><?php echo _XF_PRJ_USETASKDEP; ?></B>
</td>
</tr>

<?php
/*
<tr>
<td>
 <INPUT TYPE="CHECKBOX" NAME="use_cvs" VALUE="1" <?php echo c($group->usesCVS()); ?> ><BR>
</td>
<td>
<B>Use CVS</B>
</td>
</tr>
*/
?>

<tr>
<td>
 <INPUT TYPE="CHECKBOX" NAME="use_news" VALUE="1" <?php echo c($group->usesNews()); ?> ><BR>
</td>
<td>
<B><?php echo _XF_PRJ_USENEWS; ?></B>
</td>
</tr>

<tr>
<td>
 <INPUT TYPE="CHECKBOX" NAME="use_docman" VALUE="1" <?php echo c($group->usesDocman()); ?> >
</td>
<td>
<B><?php echo _XF_PRJ_USEDOCMGR; ?></B>
</td>
</tr>

</table>


<P><?php echo _XF_PRJ_WISHDEFAULTEMAILADDRESS; ?><BR>
<B><?php echo _XF_PRJ_NEWTASKASSIGNMENTS; ?>:</B><BR>
<INPUT TYPE="TEXT" NAME="new_task_address" VALUE="<?php echo $group->PMEmailAddress(); ?>" SIZE="25" MAXLENGTH="250">
(<?php echo _XF_PRJ_SENDONALLUPDATES; ?>)
<INPUT TYPE="CHECKBOX" NAME="send_all_tasks" VALUE="1" <?php echo c($group->PMEmailAll()); ?> ><BR>

<HR>
<P><INPUT type="submit" name="submit" value="<?php echo _XF_G_UPDATE; ?>">
</FORM>

<?php
CloseTable();
include ("../../../footer.php");
?>
