<?php
/**
  *
  * Project Admin: Edit Releases of Packages
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: editreleases.php,v 1.3 2002/06/07 09:17:34 arjenvanefferen Exp $
  *
  */


/* Updated rewrite of the File Release System to clean up the UI 
 * a little and incorporate FRS.class.		-Darrell
 */

include_once ("../../../mainfile.php");

$langfile="project.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/include/frs.class");
require_once(XOOPS_ROOT_PATH."/xf/project/admin/project_admin_utils.php");
require_once(XOOPS_ROOT_PATH."/xf/include/project_summary.php");

project_check_access ($group_id);

// get current information
$group =& group_get_object($group_id);
$perm  =& $group->getPermission( $xoopsUser );

if (!$perm->isReleaseTechnician()) {
	redirect_header(XOOPS_URL."/",4,_XF_G_PERMISSIONDENIED."<br />"._XF_PRJ_NOTRELEASETECHNIC);
	exit;
}

include ("../../../header.php");
OpenTable();

echo "<b>"._XF_G_PROJECT.": ".$group->getPublicName()."</b><br /><br />";
echo "<B style='font-size:16px;align:left;'>"._XF_PRJ_RELEASENEWFILEVERSION."</B><br />";
project_tabs ('admin', $group_id);
project_admin_header($group_id, $perm->isAdmin());

// Create a new FRS object
$frs = new FRS($group_id);

/*
 * Here's where we do the dirty work based on the step the user has chosen
 */

// Edit release info
if ($step1) {
	$exec_changes = true;

	// If we haven't encountered any problems so far then save the changes
	if ($exec_changes == true) {
		if ($frs->frsChangeRelease($release_date, $release_name, $preformatted, $status_id, $release_notes, $release_changes, $package_id, $release_id)) {
			$feedback .= " "._XF_PRJ_DATASAVED." ";
		} else {
			$feedback .= $frs->getErrorMessage();
		}
	}
} 

// Add file(s) to the release
if ($step2) {	
	// For every file selected add that file to this release
		$frs->frsAddFile(time(), $filename, $file_url, $file_size, time(), $release_id, $package_id);
		if( !$frs->isError() ) {
			$feedback .= " "._XF_PRJ_FILESADDED." ";
		}
}

// Edit/Delete files in a release
if ($step3) {	
	// If the user chose to delete the file and he's sure then delete the file
	if( $step3 == "Delete File" && $im_sure ) {
		// delete the file from the database
		$frs->frsDeleteFile($file_id);
		if( !$frs->isError() ) {
			$feedback .= " "._XF_PRJ_FILEDELETED." ";
		}
	// Otherwise update the file information
	} else {
		$frs->frsChangeFile($release_time, $type_id, $processor_id, $file_id, $file_url, $new_release_id, $package_id);
		if( !$frs->isError() ) {
			$feedback .= " "._XF_PRJ_FILEUPDATED." ";
		}
	}
}

// Send email notice
if ($step4) {
		$frs->frsSendNotice($group_id, $release_id, $package_id);
		if( !$frs->isError() ) {
				$feedback .= " "._XF_PRJ_EMAILNOTICESENT." ";
		}
		else {
				$feedback .= " ".$frs->getErrorMessage();
		}
}

if ($package_id) {
	//narrow the list to just this package's releases
	$pkg_str = "AND p.package_id='$package_id'";
}
echo $feedback;
if( !$release_id ) {
	$res = $frs->frsGetReleaseList($pkg_str);
	$rows = $xoopsDB->getRowsNum($res);
	if (!$res || $rows < 1) {
	  if ($package_id)
		  echo "<B>"._XF_PRJ_NORELEASESTHISPACKAGEDEFINED."</B>";
		else
		  echo "<B>"._XF_PRJ_NORELEASESDEFINED."</B>";
		echo $xoopsDB->error();
	} else {
		/*
			Show a list of releases
			For this project or package
		*/
		?>
		<table border="0" width="95%" cellpadding="0" cellspacing="0" align="center" valign="top"><tr><td class='bg2'>
    <table border="0" cellpadding="4" cellspacing="1" width="100%">
    <tr class='bg3' align='left'>
	    <td align="center"><span class='fg2'><b><?php echo _XF_PRJ_RELEASENAME; ?></b></span></td>
	    <td align="center"><span class='fg2'><b><?php echo _XF_PRJ_PACKAGENAME; ?></b></span></td>
	    <td align="center"><span class='fg2'><b><?php echo _XF_PRJ_STATUS; ?></b></span></td>
    </tr>

		<?php

		for ($i=0; $i<$rows; $i++) {

      echo "<tr class='".($i%2>0?"bg1":"bg3")."'>"
			    ."<td>"
					."<font size='-1'>"
					.$ts->makeTboxData4Show(unofficial_getDBResult($res,$i,'release_name'))
					."[ <a href='editreleases.php?package_id=".$package_id."&release_id=".unofficial_getDBResult($res,$i,'release_id')."&group_id=".$group_id."'>"._XF_PRJ_EDITTHISRELEASE."</a> ]"
					."</font>"
					."</td>"
					."<td>"
					."<font size='-1'>"
					.$ts->makeTboxData4Show(unofficial_getDBResult($res,$i,'package_name'))
					."[ <a href='editpackages.php?group_id=".$group_id."'>"._XF_PRJ_EDITTHISPACKAGE."</a> ]"
					."</font>"
					."</td>"
					."<td>"
					."<font size='-1'>".unofficial_getDBResult($res,$i,'status_name')."</font>"
					."</td>"
					."</tr>"
					."</form>";
	  }
	  echo "</table></td></tr></table>\n";
  }
}

/*
 * Show the forms for each step
 */
if( $release_id ) {
?>

<B><?php echo _XF_PRJ_STEP1; ?></B><p>

<form enctype="multipart/form-data" method="post" action="<?php echo $PHP_SELF; ?>">
<input type="hidden" name="group_id" value="<?php echo $group_id; ?>">
<input type="hidden" name="package_id" value="<?php echo $package_id; ?>">
<input type="hidden" name="release_id" value="<?php echo $release_id; ?>">
<input type="hidden" name="step1" value="1">
<table border="0" cellpadding="1" cellspacing="1">
<?php
	if(!($result = $frs->frsGetRelease($release_id))) {
		$feedback .= $frs->getErrorMessage();
	}
?>
<tr>
	<td width="10%"><b><?php echo _XF_PRJ_RELEASEDATE; ?>:<b></td>
	<td><input type="text" name="release_date" value="<?php echo date('Y-m-d',unofficial_getDBResult($result,0,'release_date')) ?>" size="10" maxlength="10"></td>
</tr>
<tr>
	<td><b><?php echo _XF_PRJ_RELEASENAME; ?>:<b></td>
	<td><input type="text" name="release_name" value="<?php echo $ts->makeTboxData4Edit(unofficial_getDBResult($result,0,'release_name')); ?>"></td>
</tr>
<tr>
	<td><b><?php echo _XF_PRJ_STATUS; ?>:</b></td>
	<td><?php echo frs_show_status_popup('status_id',unofficial_getDBResult($result,0,'status_id')); ?>
	</td>
</tr>
<tr>
	<td><b><?php echo _XF_PRJ_OFPACKAGE; ?>:</b></td>
	<td><?php echo frs_show_package_popup($group_id,'new_package_id',unofficial_getDBResult($result,0,'package_id')); ?></td>
</tr>
<tr>
	<td colspan="2">
		<br><?php echo _XF_PRJ_STEP1EDITRELEASENOTES; ?>
		<br>
	</td>
</tr>
<tr>
	<td COLSPAN=2>
		<b><?php echo _XF_PRJ_PASTENOTES; ?>:</b><br>
		<textarea name="release_notes" rows="10" cols="60" wrap="soft"><?php echo $ts->makeTareaData4Edit(unofficial_getDBResult($result,0,'notes')); ?></textarea>
	</td>
</TR>
<TR>
	<td COLSPAN=2>
		<b><?php echo _XF_PRJ_PASTELOG; ?>:</b><br>
		<textarea name="release_changes" rows="10" cols="60" wrap="soft"><?php echo $ts->makeTareaData4Edit(unofficial_getDBResult($result,0,'changes')); ?></textarea>
	</td>
</tr>
<TR>
	<TD COLSPAN=2>
		<br>
		<input type="checkbox" name="preformatted" value="1" <?php echo ((unofficial_getDBResult($result,0,'preformatted'))?'checked':''); ?>><?php echo _XF_PRJ_PRESERVEFORMAT; ?>.
		<p>
		<input type="submit" name="submit" value="<?php echo _XF_PRJ_SUBMITREFRESH; ?>">
	</td>
</tr>
</table>
</form>

<hr noshade>

<B><?php echo _XF_PRJ_STEP2; ?></B><p>

<form method="post" action="<?php echo $PHP_SELF; ?>">
<input type="hidden" name="group_id" value="<?php echo $group_id; ?>">
<input type="hidden" name="package_id" value="<?php echo $package_id; ?>">
<input type="hidden" name="release_id" value="<?php echo $release_id; ?>">
<input type="hidden" name="step2" value="1">

<?php echo _XF_PRJ_STEP2WHENUPLOADED; ?>
<br><br>
<table border="0" cellpadding="3" cellspacing="3">
<tr>
	<td><b><?php echo _XF_PRJ_FILENAME; ?>:<b></td>
	<td><input type="text" name="filename" size='40' value="<?php echo $ts->makeTboxData4Edit(unofficial_getDBResult($result,0,'filename')); ?>"></td>
</tr>
<tr>
	<td><b><?php echo _XF_PRJ_FILEURL; ?>:<b></td>
	<td><input type="text" name="file_url" size='80' value="<?php echo $ts->makeTboxData4Edit(unofficial_getDBResult($result,0,'file_url')); ?>"></td>
</tr>
<tr>
	<td><b><?php echo _XF_PRJ_FILESIZE; ?>:<b></td>
	<td><input type="text" name="file_size" size='10' value="<?php echo $ts->makeTboxData4Edit(unofficial_getDBResult($result,0,'file_size')); ?>"> bytes</td>
</tr>
</table>
<input type="submit" name="submit" value="<?php echo _XF_PRJ_ADDFILE; ?>">
</form>

<hr noshade>

<B><?php echo _XF_PRJ_STEP3; ?></B><p>

<?php
	// Get a list of files associated with this release
	$res = $frs->frsGetReleaseFiles($release_id);
	if( !$frs->isError() ) {
		$rows = $xoopsDB->getRowsNum($res);
		if($rows < 1) {
			print("<B>"._XF_PRJ_NOFILESINRELEASE."</B>\n");
		} else {
			echo _XF_PRJ_ONCEADDEDMUSTUPDATE;

		?>
		<table border="0" width="95%" cellpadding="0" cellspacing="0" align="center" valign="top"><tr><td class='bg2'>
    <table border="0" cellpadding="4" cellspacing="1" width="100%">
    <tr class='bg3' align='left'>
	    <td align="center"><span class='fg2'><b><?php echo _XF_PRJ_FILENAME; ?><BR><?php echo _XF_PRJ_RELEASE; ?></b></span></td>
	    <td align="center"><span class='fg2'><b><?php echo _XF_PRJ_FILEURL; ?><BR><?php echo _XF_PRJ_RELEASEDATE; ?></b></span></td>
	    <td align="center"><span class='fg2'><b><?php echo _XF_PRJ_FILETYPE; ?>/<?php echo _XF_PRJ_PROCESSOR; ?><BR><?php echo _XF_G_UPDATE; ?></b></span></td>
    </tr>

		<?php

			for($x=0; $x<$rows; $x++) {
?>
			<form action="<?php echo $PHP_SELF; ?>" method="post">
				<input type="hidden" name="group_id" value="<?php echo $group_id; ?>">
				<input type="hidden" name="release_id" value="<?php echo $release_id; ?>">
				<input type="hidden" name="package_id" value="<?php echo $package_id; ?>">
				<input type="hidden" name="file_id" value="<?php echo unofficial_getDBResult($res,$x,'file_id'); ?>">
				<input type="hidden" name="step3" value="1">
				<tr class='<?php echo ($x%2>0?"bg1":"bg3"); ?>'>
					<td nowrap><font size="-1"><?php echo unofficial_getDBResult($res,$x,'filename'); ?></td>
					<td><font size="-1"><input type="text" name="file_url" value="<?php echo unofficial_getDBResult($res,$x,'file_url'); ?>" size="40"></td>
					<td><font size="-1"><?php echo frs_show_filetype_popup ('type_id', unofficial_getDBResult($res,$x,'type_id')); ?> / <?php echo frs_show_processor_popup ('processor_id', unofficial_getDBResult($res,$x,'processor_id')); ?></td>
				</tr>
				<tr class="<?php echo ($x%2>0?"bg1":"bg3"); ?>">
					<td>
						<font size="-1">
							<?php echo frs_show_release_popup ($group_id, $name='new_release_id',unofficial_getDBResult($res,$x,'release_id')); ?>
						</font>
					</td>
					<td>
						<font size="-1">
							<input type="text" name="release_time" value="<?php echo date('Y-m-d',unofficial_getDBResult($res,$x,'release_time')); ?>" size="10" maxlength="10">
						</font>
					</td>
					<td><font size="-1"><input type="submit" name="submit" value="<?php echo _XF_G_UPDATE; ?>"></td>
				</tr>
				</form>

			<form action="<?php echo $PHP_SELF; ?>" method="post">
				<input type="hidden" name="group_id" value="<?php echo $group_id; ?>">
				<input type="hidden" name="release_id" value="<?php echo $release_id; ?>">
				<input type="hidden" name="package_id" value="<?php echo $package_id; ?>">
				<input type="hidden" name="file_id" value="<?php echo unofficial_getDBResult($res,$x,'file_id'); ?>">
				<input type="hidden" name="step3" value="Delete File">
				<tr class="<?php echo ($x%2>0?"bg1":"bg3"); ?>">
					<td><font size="-1">&nbsp;</td>
					<td><font size="-1">&nbsp;</td>
					<td>
						<font size="-1">
							<input type="submit" name="submit" value="<?php echo _XF_PRJ_DELETEFILE; ?>"> <input type="checkbox" name="im_sure" value="1"> <?php echo _XF_PRJ_IMSURE; ?>
						</font>
					</td>
				</tr>
			</form>
<?php
			}
			echo "</table></td></tr></table>";
		}
	} else {
		$feedback .= $frs->getErrorMessage();
	}
?>


<hr noshade>

<B><?php echo _XF_PRJ_STEP4; ?></B><p>

<?php 
	$mons = $frs->frsGetReleaseMonitors($package_id); 
	if( $mons > 0 ) {
?>

<form action="<?php echo $PHP_SELF; ?>" method="post">
	<input type="hidden" name="group_id" value="<?php echo $group_id; ?>">
	<input type="hidden" name="release_id" value="<?php echo $release_id; ?>">
	<input type="hidden" name="package_id" value="<?php echo $package_id; ?>">
	<input type="hidden" name="step4" value="Email Release">
	<?php printf(_XF_PRJ_USERSAREMONITORING, $mons); ?><br>
	<input type="submit" value="<?php echo _XF_PRJ_SENDNOTICE; ?>"><input type="checkbox" value="sure"> <?php echo _XF_PRJ_IMSURE; ?>.
</form>

<?php
	} else {
  
	  echo _XF_PRJ_NOBODYMONITORING;

	}
}
CloseTable();
include ("../../../footer.php");
?>
