<?php
/**
  *
  * Project Admin page to edit Trove categorization of the project
  *
  * This page is linked from index.php
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: group_trove.php,v 1.3 2002/06/07 09:17:34 arjenvanefferen Exp $
  *
  */

include_once("../../../mainfile.php");

$langfile="project.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/project/admin/project_admin_utils.php");
require_once(XOOPS_ROOT_PATH."/xf/include/trove.php");
require_once(XOOPS_ROOT_PATH."/xf/include/project_summary.php");

project_check_access ($group_id);

// get current information
$group =& group_get_object($group_id);
$perm  =& $group->getPermission( $xoopsUser );

// Check for submission. If so, make changes and redirect

if ($submit && $root1) {
	group_add_history ('Changed Trove',$rm_id,$group_id);

	// there is at least a $root1[xxx]
	while (list($rootnode,$value) = each($root1)) {
		// check for array, then clear each root node for group
		$xoopsDB->queryF("DELETE FROM ".$xoopsDB->prefix("xf_trove_group_link")." "
		                ."WHERE group_id='$group_id' "
										."AND trove_cat_root='$rootnode'");
		
		for ($i=1; $i <= $TROVE_MAXPERROOT; $i++) {
			$varname = 'root'.$i;
			// check to see if exists first, then insert into DB
			if (${$varname}[$rootnode]) {
				trove_setnode($group_id,${$varname}[$rootnode],$rootnode);
			}
		}
	}
	redirect_header(XOOPS_URL."/xf/project/admin/?group_id=".$group_id,0,_XF_PRJ_GROUPTROVEALTERED);
	exit;
}

include ("../../../header.php");
OpenTable();

echo "<b>"._XF_G_PROJECT.": ".$group->getPublicName()."</b><br /><br />";
echo "<B style='font-size:16px;align:left;'>"._XF_PRJ_GROUPTROVEINFORMATION."</B><br />";
project_tabs ('admin', $group_id);
project_admin_header($group_id, $perm->isAdmin());


echo "<H4>"._XF_PRJ_EDITTROVECATEGORIZATION."</H4>";

echo "<p>"._XF_PRJ_EDITTROVEEXPLAIN1."</p>"
    ."<p>"._XF_PRJ_EDITTROVEEXPLAIN2."</p>"
    ."<FORM action='".$PHP_SELF."' method='POST'>";


$CATROOTS = trove_getallroots();
while (list($catroot,$fullname) = each($CATROOTS)) {
	echo "<HR><P><B>".$fullname."</B>";

	$res_grpcat = $xoopsDB->queryF("SELECT trove_cat_id "
	                              ."FROM ".$xoopsDB->prefix("xf_trove_group_link")." "
					."WHERE group_id='$group_id' "
					."AND trove_cat_root='$catroot'");

	for ($i=1; $i <= $GLOBALS['TROVE_MAXPERROOT']; $i++) {
		// each drop down, consisting of all cats in each root
		$name= "root$i"."[$catroot]";
		// see if we have one for selection
		if ($row_grpcat = $xoopsDB->fetchArray($res_grpcat)) {
			$selected = $row_grpcat["trove_cat_id"];	
		} else {
			$selected = 0;
		}
		trove_catselectfull($catroot,$selected,$name);
	}
}

?>

<INPUT type="hidden" name="group_id" value="<?php echo $group_id; ?>">
<P><INPUT type="submit" name="submit" value="<?php echo _XF_PRJ_UPDATEALLCATEGORYCHANGES; ?>">
</FORM>

<?php
CloseTable();
include ("../../../footer.php");
?>
