<?php
/**
  *
  * Project Admin Main Page
  *
  * This page contains administrative information for the project as well
  * as allows to manage it. This page should be accessible to all project
  * members, but only admins may perform most functions.
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: index.php,v 1.4 2002/06/07 09:17:34 arjenvanefferen Exp $
  *
  */

include_once ("../../../mainfile.php");

$langfile="project.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/project/admin/project_admin_utils.php");
require_once(XOOPS_ROOT_PATH."/xf/include/project_summary.php");

project_check_access ($group_id);

// get current information
$group =& group_get_object($group_id);
$perm  =& $group->getPermission( $xoopsUser );

// Only admin can make modifications via this page
if ($perm->isAdmin() && $func) {
	/*
		updating the database
	*/
	if ($func=='adduser') {
		/*
			add user to this project
		*/

		if (!$group->addUser($form_unix_name)) {
			$feedback .= $group->getErrorMessage();
		} else {
			$feedback = ' '._XF_GRP_ADDEDUSER.' ';
		}

	} else if ($func=='rmuser') {
		/*
			remove a user from this group
		*/
		if (!$group->removeUser($rm_id)) {
			$feedback .= $group->getErrorMessage();
		} else {
			$feedback = ' '._XF_GRP_REMOVEDUSER.' ';
		}
	}

}

$group->clearError();

include ("../../../header.php");
OpenTable();

echo "<b>"._XF_G_PROJECT.": ".$group->getPublicName()."</b><br /><br />";
echo "<B style='font-size:16px;align:left;'>"._XF_PRJ_ADMINSUMMARY."</B><br />";
project_tabs ('admin', $group_id);
project_admin_header($group_id, $perm->isAdmin());
?>

<TABLE width=100% cellpadding=2 cellspacing=2 border=0>
<TR valign=top><TD width=50%>

<?php
$title = _XF_PRJ_MISCPROJECTINFO;
$content = "<p>"._XF_G_DESCRIPTION.": ".$ts->makeTareaData4Show($group->getDescription())."<br /></p>"
          ._XF_G_HOMEPAGE.": <b>".$group->getHomepage()."</b><br />"
		."<HR NOSHADE>"
		."<p><b>"._XF_PRJ_TROVECATEGORIZATION.":</b> [ <a href='".XOOPS_URL."/xf/project/admin/group_trove.php?group_id=".$group->getID()."'>"
		._XF_G_EDIT."</A> ]</p>"
		."<HR NOSHADE>"
		."<p><b>"._XF_PRJ_SHOWINGTHELOGO.":</b><br />"
		."<font size=-1>"._XF_PRJ_IFUSESHOWTHELOGO."</font>"
		."<p>".$ts->makeTboxData4Edit("<A href='".XOOPS_URL."'><IMG src='".XOOPS_URL."/xf/xflogo.php?group_id=".$group_id."' width='155' height='60' border='0' alt='XoopsForge Logo'></A>")
		."<p><img src='".XOOPS_URL."/xf/images/xflogo-155-1.gif' width='155' height='66'>";

themesidebox($title, $content);


echo "</TD><TD>&nbsp;</TD><TD width='50%'>";

$title = _XF_PRJ_GROUPMEMBERS;
/*

	Show the members of this project

*/

$res_memb = $xoopsDB->query("SELECT u.name,u.uid,u.uname,ug.admin_flags "
                           ."FROM ".$xoopsDB->prefix("users")." u,".$xoopsDB->prefix("xf_user_group")." ug "
                           ."WHERE u.uid=ug.user_id "
                           ."AND ug.group_id='$group_id'");

$content = "<TABLE WIDTH='100%' BORDER='0'>";

while ($row_memb = $xoopsDB->fetchArray($res_memb)) {

	if (stristr($row_memb['admin_flags'], 'A')) {
		$img = "trash-x.png";
	} else {
		$img = "trash.png";
	}
	if ($perm->isAdmin()) {
		$button = "<INPUT TYPE='IMAGE' NAME='DELETE' SRC='".XOOPS_URL."/xf/images/ic/".$img."' HEIGHT='16' WIDTH='16' BORDER='0'>";
	} else {
		$button = "&nbsp;";
	}
	$content .= "<FORM ACTION='rmuser.php' METHOD='POST'>"
             ."<INPUT TYPE='HIDDEN' NAME='func' VALUE='rmuser'>"
             ."<INPUT TYPE='HIDDEN' NAME='return_to' VALUE='".$REQUEST_URI."'>"
             ."<INPUT TYPE='HIDDEN' NAME='rm_id' VALUE='".$row_memb['uid']."'>"
             ."<INPUT TYPE='HIDDEN' NAME='group_id' VALUE='". $group_id ."'>"
             ."<TR><TD ALIGN='MIDDLE'>".$button."</TD></FORM>"
             ."<TD><A href='".XOOPS_URL."/userinfo.php?uid=".$row_memb['uid']."'>".$row_memb['uname']."</A></TD></TR>";
}
$content .= "</TABLE>";

/*
	Add member form
*/

if ($perm->isAdmin()) {

	// After adding user, we go to the permission page for one
$content .= "<HR NoShade SIZE='1'>"
           ."<FORM ACTION='userpermedit.php?group_id=".$group->getID()."' METHOD='POST'>"
           ."<INPUT TYPE='hidden' NAME='func' VALUE='adduser'>"
           ."<TABLE WIDTH='100%' BORDER='0'>"
           ."<TR><TD><B>"._XF_PRJ_USERNAME.":</B></TD><TD><INPUT TYPE='TEXT' NAME='form_unix_name' SIZE='10' VALUE=''></TD></TR>"
           ."<TR><TD COLSPAN='2' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='submit' VALUE='"._XF_PRJ_ADDUSER."'></TD></TR></FORM>"
           ."</TABLE>"

           ."<HR NoShade SIZE='1'>"
           ."<div align='center'>"
           ."[ <A href='".XOOPS_URL."/xf/project/admin/userperms.php?group_id=".$group->getID()."'>"._XF_PRJ_EDITMEMBERPERMS."</A> ]"
           ."</div>";
}
 
themesidebox($title, $content);

echo "</TD></TR>"
    ."<TR valign=top><TD width='50%'>";

/*
	Tool admin pages
*/

$title = _XF_PRJ_TOOLADMIN;

$content = "<BR>"
          ."<A HREF='".XOOPS_URL."/xf/tracker/admin/?group_id=".$group->getID()."'>"._XF_PRJ_TRACKERADMIN."</A><BR>"
          ."<A HREF='".XOOPS_URL."/xf/docman/admin/?group_id=".$group->getID()."'>"._XF_PRJ_DOCMANAGERADMIN."</A><BR>"
          ."<A HREF='".XOOPS_URL."/xf/news/admin/?group_id=".$group->getID()."'>"._XF_PRJ_NEWSADMIN."</A><BR>"
          ."<A HREF='".XOOPS_URL."/xf/pm/admin/?group_id=".$group->getID()."'>"._XF_PRJ_TASKADMIN."</A><BR>"
          ."<A HREF='".XOOPS_URL."/xf/forum/admin/?group_id=".$group->getID()."'>"._XF_PRJ_FORUMADMIN."</A><BR>";

themesidebox($title, $content);

echo "</TD>"
    ."<TD>&nbsp;</TD>"
    ."<TD width='50%'>";

$title = _XF_PRJ_FILERELEASES;

$content = "&nbsp;<BR>"
          ."<CENTER>"
					."[ <A href='editpackages.php?group_id=".$group_id."'><B>"._XF_PRJ_RELEASEEDITFILERELEASES."</B></A> ]"
					."</CENTER>"
					."<HR>"
					."<B>"._XF_PRJ_PACKAGES.":</B> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
					."<A href='".XOOPS_URL."/xf/docman/display_doc.php?docid=32&group_id=1'><i>"._XF_PRJ_WHATISTHIS."</i></A> ("._XF_PRJ_VERYIMPORTANT.")"
					."<P>";
					
$res_module = $xoopsDB->query("SELECT * FROM ".$xoopsDB->prefix("xf_frs_package")." WHERE group_id='$group_id'");
while ($row_module = $xoopsDB->fetchArray($res_module)) {
	$content .= $row_module['name']."<BR>";
}

themesidebox($title, $content);

?>
</TD>
</TR>
</TABLE>

<?php

CloseTable();
include ("../../../footer.php");
?>
