<?php
/**
  *
  * Group Admin page to confirm removal of user from group
  *
  * This page is called from Project/Foundry Admins when admin requests
  * removal of a developer. This page checks whether it is possible
  * to remove one, if no, shows decription why not, else presents
  * admin with the confirmation form. Results of this form are submitted
  * back to calling Project/Foundry Admin page (i.e. very removal is
  * performed there). Since Project/Foundry Admins use slightly different
  * parameter passing interface, there's a bit of dirty magic here.
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: rmuser.php,v 1.3 2002/06/07 09:17:34 arjenvanefferen Exp $
  *
  */

include_once ("../../../mainfile.php");

$langfile="project.php";
require_once(XOOPS_ROOT_PATH."/class/xoopsuser.php");
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/project/admin/project_admin_utils.php");
require_once(XOOPS_ROOT_PATH."/xf/include/project_summary.php");

project_check_access ($group_id);

// get current information
$group =& group_get_object($group_id);
$perm  =& $group->getPermission( $xoopsUser );

// Do some text substitutions below
if ($group->getType() == 2) {
	$type = "foundry";
	// foundries hate explicit group_id
	$passed_group_id = "";
} else {
	$type = "project";
	$passed_group_id = "<input type='hidden' name='group_id' value='".$group_id."'>";
}

// Need to check if user being removed is admin
$rm_user = new XoopsUser($rm_id);
$perm = $group->getPermission($rm_user);

if ($perm->isAdmin()) {
	redirect_header($return_to, 2, sprintf(_XF_PRJ_CANNOTREMOVEXXXADMIN, $type));
	exit;
}

include ("../../../header.php");
OpenTable();

echo "<b>"._XF_G_PROJECT.": ".$group->getPublicName()."</b><br /><br />";
echo "<B style='font-size:16px;align:left;'>"._XF_PRJ_MEMBERADMINISTRATION."</B><br />";
project_tabs ('admin', $group_id);
project_admin_header($group_id, $perm->isAdmin());
?>

<h4><?php printf(_XF_PRJ_REMOVINGDEVELOPERFROM, ucfirst($type)); ?></h4>
<p>
<?php printf(_XF_PRJ_CONFIRMREMOVEDEVELOPER, $type); ?>:
</p>

<table>
<tr><td>

<form action="<?php echo $return_to; ?>" method="POST">
<input type="hidden" name="func" value="rmuser">
<?php echo $passed_group_id; ?>
<input type="hidden" name="rm_id" value="<?php echo $rm_id; ?>">
<input type="submit" value="<?php echo _XF_G_REMOVE; ?>">
</form>

</td><td>

<form action="<?php echo $return_to; ?>" method="GET">
<?php echo $passed_group_id; ?>
<input type="submit" value="<?php echo _XF_G_CANCEL; ?>">
</form>

</td></tr>
</table>

<?php
CloseTable();
include ("../../../footer.php");
?>
