<?php
/**
  *
  * Project Admin page to edit permissions for the specific group member
  *
  * This page is linked from userperms.php and from forms to add users
  * to group (located on Project/Foundry Admin main pages).
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: userpermedit.php,v 1.4 2002/06/18 07:39:59 arjenvanefferen Exp $
  *
  */


include_once ("../../../mainfile.php");

$langfile="project.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/project/admin/project_admin_utils.php");
require_once(XOOPS_ROOT_PATH."/xf/include/project_summary.php");
require_once(XOOPS_ROOT_PATH."/xf/include/tracker/ArtifactType.class");
require_once(XOOPS_ROOT_PATH."/class/xoopsuser.php");

project_check_access ($group_id);

// get current information
$group =& group_get_object($group_id);
$perm  =& $group->getPermission( $xoopsUser );

// Builds role selection box with given selected item
function member_role_box($name, $checked) {
	global $member_roles, $xoopsDB;
	
	if (!$member_roles) {
		$sql = "SELECT category_id,name FROM ".$xoopsDB->prefix("xf_people_job_category");
		$member_roles = $xoopsDB->queryF($sql);
	}
	return html_build_select_box($member_roles,$name,$checked,true,_XF_G_UNDEFINED);
}

// Since there're lot of permissions, and each of them has complex
// HTML rendition (SELECT boxes, etc.), this function is used to reduce
// the background noise.
function render_row($name, $val, $i) {
	echo "<tr class='".($i%2>0?"bg1":"bg3")."'>"
	    ."<td>".$name."</td>"
			."<td>".$val."</td></tr>";
}

// ########################### form submission, make updates

// Netscape allows to submit single-field form by pressing
// Return in the field. In this case, it won't set value for
// submit button
if ($submit || $form_unix_name) {

	if ($func == 'adduser') {

		/*
			We came here from Add User page, need to add user
			and fall thru to show permissions for one
		*/
		$res = $xoopsDB->query("SELECT * FROM ".$xoopsDB->prefix("users")." WHERE uname='".$form_unix_name."'");
		if (!$res || $xoopsDB->getRowsNum($res) == 0)
		{
		  redirect_header($GLOBALS["HTTP_REFERER"],1,_XF_PRJ_USERDOESNOTEXSIT);
		  exit();
		}
		$u = new XoopsUser($xoopsDB->fetchArray($res));

		if (!$group->addUser($u)) {
			echo "Error ".$group->getErrorMessage();
		} else {
			$feedback = " "._XF_PRJ_USERADDEDSUCCESSFULLY."<br>";
		}

		$user_id = $u->getVar("uid");

	} elseif ($addtotracker) {

		$u = new XoopsUser($user_id);
		//
		//  if "add all" option, get list of ArtifactTypes
		//  that this user is not already a member of
		//
		if ($add_all) {
		  $sql = "SELECT agl.group_artifact_id "
			      ."FROM ".$xoopsDB->prefix("xf_artifact_group_list")." agl "
						."LEFT JOIN ".$xoopsDB->prefix("xf_artifact_perm")." ap ON agl.group_artifact_id=ap.group_artifact_id "
						."AND ap.user_id='".$u->getVar("uid")."' "
						."WHERE ap.group_artifact_id IS NULL "
						."AND agl.group_id='$group_id'";
						
      $res = $xoopsDB->query($sql);
			$addtoids = util_result_column_to_array($res);
		}

		//
		//	Now take the array of ids and add this user to them
		//
		
		$count = count($addtoids);

		for ($i=0; $i<$count; $i++) {
			$ath = new ArtifactType($group,$addtoids[$i]);

			$ath->addUser($u->getVar("uid"));
			if ($ath->isError()) {
				$feedback .= $addtoids[$i] .': '. $ath->getErrorMessage();
				$was_error = true;
			}
		}

	} else {

		/*
			Else, we are updating user's permissions
		*/
		$u = new XoopsUser ($user_id);

		// XXX: remove when CVS roles will be activated!
		$cvs_flags = 1;

		//call to control function in the $Group object
		if (
		     $group->updateUser($user_id,       $admin_flags,
				                    $forum_flags,   $project_flags,
														$doc_flags,     $cvs_flags,
														$release_flags, $member_role,
														$artifact_flags
													 ) )
		{

			group_add_history (_XF_PRJ_CHANGEDPERMISSIONSFOR, $u->getVar("uname"), $group_id);

			//  
			//  Delete the checked ids
			//

			//	keep an assoc array of artifacts this user 
			//	was removed from, so we don't then try to update
			//	those artifact type perms in the next step
			$del_arr = array();

			$count = count($deletefrom);
			for ($i=0; $i<$count; $i++) {
				$del_arr["$deletefrom[$i]"]=true;
				$ath = new ArtifactType($group,$deletefrom[$i]);
				$ath->deleteUser($user_id);
				if ($ath->isError()) {
					$feedback .= $deletefrom[$i] .': '. $ath->getErrorMessage();
					$was_error=true;
				}
			}

			//
			//  Handle the 2-D array of group_artifact_id/permission level
			//
			$count = count($updateperms);

			for ($i=0; $i<$count; $i++) {
				//
				//	quick check of that assoc array to prevent 
				//	updating of perms that don't exist anymore
				//
				if (!$del_arr["$updateperms[$i][0]"]) {
					$ath = new ArtifactType($group,$updateperms[$i][0]);
					$ath->updateUser($user_id,$updateperms[$i][1]);
					if ($ath->isError()) {
						$feedback .= $updateperms[$i][0] .': '. $ath->getErrorMessage();
						$was_error=true;
					} 
				}
			}
			
			//if no errors occurred, show just one feedback message
			//instead of the coredump of messages;
			if (!$was_error) {
				$feedback = ' '._XF_PRJ_PERMISSIONSUPDATED.'<br>';
			}
		} else {
			$feedback .= $group->getErrorMessage();
		}
	}

} else {
	//
	//  Set up this user's object
	//
	$u = new XoopsUser($user_id);
	if (!$u || !is_object($u)) {
		echo "Error creating user object";
		exit;
  }
}

include ("../../../header.php");
OpenTable();

echo "<b>"._XF_G_PROJECT.": ".$group->getPublicName()."</b><br /><br />";
echo "<B style='font-size:16px;align:left;'>"._XF_PRJ_PROJECTDEVPERMISSIONS." - ".$u->getVar("name")." (".$u->getVar("uname").")</B><br />";
project_tabs ('admin', $group_id);
project_admin_header($group_id, $perm->isAdmin());

// Show description of roles/permissions

if ( file_exists(XOOPS_ROOT_PATH."/xf/language/".$xoopsConfig['language']."/project_text_2.php") ) {
	include(XOOPS_ROOT_PATH."/xf/language/".$xoopsConfig['language']."/project_text_2.php");
} else {
	include(XOOPS_ROOT_PATH."/xf/language/english/project_text_2.php");
}

$res_dev = $xoopsDB->query("SELECT * "
                          ."FROM ".$xoopsDB->prefix("xf_user_group")." "
			                    ."WHERE group_id='$group_id' "
			                    ."AND user_id='$user_id'");
echo $feedback;

echo "<B style='font-size:16px;align:left;'>".$u->getVar("name")." (".$u->getVar("uname").")</B><br />";

if (!$res_dev || $xoopsDB->getRowsNum($res_dev) < 1) {
	echo "<H4>"._XF_PRJ_DEVELOPERNOTFOUND."</H4>";
	echo $xoopsDB->error();
} else {
	echo "<P><FORM action='".$PHP_SELF."?group_id=".$group_id."&user_id=".$user_id."' method='post'>";

	$row_dev = $xoopsDB->fetchArray($res_dev);

  ?>
		<table border="0" width="95%" cellpadding="0" cellspacing="0" align="center" valign="top"><tr><td class='bg2'>
    <table border="0" cellpadding="4" cellspacing="1" width="100%">
    <tr class='bg3' align='left'>
	    <td align="center"><span class='fg2'><b><?php echo _XF_G_PROPERTY; ?></b></span></td>
	    <td align="center"><span class='fg2'><b><?php echo _XF_G_VALUE; ?></b></span></td>
    </tr>
	<?php
	render_row(
		_XF_PRJ_PROJECTROLE,
		member_role_box('member_role',$row_dev['member_role']),
		$i++
	);

	render_row(
		_XF_PRJ_PROJECTADMIN,
		html_build_checkbox('admin_flags', 'A', stristr($row_dev['admin_flags'],'A')),
		$i++
	);

	render_row(
		_XF_PRJ_RELEASETECHNICIAN,
		html_build_checkbox('release_flags', '1', $row_dev['release_flags']==1),
		$i++
	);

	render_row(
		_XF_PRJ_TRACKERMANAGER,
		html_build_select_box_from_arrays(
			array(0,2),
			array('-',_XF_G_ADMIN),
			'artifact_flags',$row_dev['artifact_flags'],false
		),
		$i++
	);

	$tracker_ids   = array(0,1,2,3);
	$tracker_texts = array('-',_XF_PRJ_TECHNICIAN,_XF_PRJ_ADMINTECH,_XF_G_ADMIN);

	render_row(
		_XF_PRJ_PROJECTTASKMANAGER,
		html_build_select_box_from_arrays(
			$tracker_ids,
			$tracker_texts,
			'project_flags',$row_dev['project_flags'],false
		),
		$i++
	);

	render_row(
		_XF_G_FORUMS,
		html_build_select_box_from_arrays(
			array(0,2),
			array('-',_XF_PRJ_MODERATOR),
			'forum_flags',$row_dev['forum_flags'],false
		),
		$i++
	);

	render_row(
		_XF_PRJ_DOCMANAGER,
		html_build_select_box_from_arrays(
			array(0,1),
			array('-',_XF_PRJ_EDITOR),
			'doc_flags',$row_dev['doc_flags'],false
		),
		$i++
	);

	//
	//	Get the list of permissions that this user has 
	//	for ArtifactTypes in this Group
	//
  $res = $xoopsDB->query("SELECT agl.group_artifact_id,agl.name,agl.description,agl.group_id,ap.user_id,ap.perm_level "
                        ."FROM ".$xoopsDB->prefix("xf_artifact_perm")." ap, ".$xoopsDB->prefix("xf_artifact_group_list")." agl "
												."WHERE ap.group_artifact_id=agl.group_artifact_id "
												."AND group_id='$group_id' "
												."AND user_id='$user_id'");

	$rows = $xoopsDB->getRowsNum($res);

	// Iterate over all trackers of the group
	for ($i=0; $i<$rows; $i++) {
		echo "<INPUT TYPE='HIDDEN' NAME='updateperms[".$i."][0]' VALUE='".unofficial_getDBResult($res,$i,'group_artifact_id')."'>"
		    ."<TR class='".($i%2>0?"bg1":"bg3")."'>"
				."<TD>".unofficial_getDBResult($res,$i,'name')."</TD>"
				."<TD><FONT size='-1'><SELECT name='updateperms[".$i."][1]'>"
				."<OPTION value='0'".(unofficial_getDBResult($res,$i,'perm_level')==0?" selected":"").">-"
				."<OPTION value='1'".(unofficial_getDBResult($res,$i,'perm_level')==1?" selected":"").">"._XF_PRJ_TECHNICIAN
				."<OPTION value='2'".(unofficial_getDBResult($res,$i,'perm_level')==2?" selected":"").">"._XF_PRJ_ADMINTECH
				."<OPTION value='3'".(unofficial_getDBResult($res,$i,'perm_level')==3?" selected":"").">"._XF_PRJ_ADMINONLY
				."</SELECT></FONT> <INPUT TYPE='CHECKBOX' NAME='deletefrom[]' VALUE='".unofficial_getDBResult($res,$i,'group_artifact_id')."'> "._XF_G_REMOVE."</TD>"
				."</TR>";
	}

	?>

	<TR class='bg3'><TD COLSPAN=2><p align="center">
		<INPUT type="submit" name="submit" value="<?php echo _XF_PRJ_UPDATEDEVELOPERPERMISSIONS; ?>">
		<INPUT type="reset" value="<?php echo _XF_G_CANCEL; ?>">
		</FORM>
	</TD></TR>

	</TABLE></TD></TR></TABLE>

	<P> 
	<H4><?php echo _XF_PRJ_ADDUSERSTHESETRACKERS; ?>:</H4>
	<P>
	<?php echo _XF_PRJ_ADDUSERSTHESETRACKERSINFO; ?>
	<P> 
	<CENTER>
	<FORM action="<?php echo $PHP_SELF.'?group_id='.$group_id.'&user_id='.$user_id ?>" method="post">
	<INPUT TYPE="HIDDEN" NAME="addtotracker" VALUE="y">
	<?php
  $sql = "SELECT agl.group_artifact_id,agl.name "
	      ."FROM ".$xoopsDB->prefix("xf_artifact_group_list")." agl "
				."LEFT JOIN ".$xoopsDB->prefix("xf_artifact_perm")." ap ON agl.group_artifact_id=ap.group_artifact_id "
				."AND ap.user_id='".$u->uid()."' "
				."WHERE ap.group_artifact_id IS NULL "
				."AND agl.group_id='$group_id'";

	$res = $xoopsDB->query($sql);
	echo $xoopsDB->error();
	echo html_build_multiple_select_box ($res,'addtoids[]',array(),8,false);
	echo "<P>"
	    ."<INPUT type='submit' name='submit' value='"._XF_PRJ_ADDTOTRACKER."'>&nbsp;"
			."<INPUT type='checkbox' name='add_all' value='1'> "._XF_PRJ_ADDTOALL."</FORM>"
			."</CENTER>";
}

CloseTable();
include ("../../../footer.php");
?>
