<?php
/**
  *
  * Project Registration: Project Information.
  *
  * This page is used to request data required for project registration:
  *	 o Project Public Name
  *	 o Project Registartion Purpose
  *	 o Project License
  *	 o Project Public Description
  *	 o Project Unix Name
  * All these data are more or less strictly validated.
  *
  * This is last page in registartion sequence. Its successful subsmission
  * leads to creation of new group with Pending status, suitable for approval.
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: projectinfo.php,v 1.3 2002/05/30 08:39:30 arjenvanefferen Exp $
  *
  */
include_once ("../../mainfile.php");

$langfile="register.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/include/vars.php");
require_once(XOOPS_ROOT_PATH."/xf/include/account.php");

if (!$xoopsUser)
{
	redirect_header($GLOBALS["HTTP_REFERER"],4,_NOPERM);
	exit;
}

include("../../header.php");
OpenTable();

if ($submit) {
	$full_name = trim($full_name);
	$purpose = trim($purpose);
	$license_other = trim($license_other);
	$description = trim($description);
	$unix_name = strtolower($unix_name);

	/*
		Fierce validation
	*/
	if (strlen($full_name) < 3) {
		$feedback .= _XF_REG_INVALIDFULLNAME;
	} else if (!account_groupnamevalid($unix_name)) {
		$feedback .= _XF_REG_INVALIDUNIXNAME;
	} else if ($xoopsDB->getRowsNum($xoopsDB->query("SELECT group_id FROM ".$xoopsDB->prefix("xf_groups")." WHERE unix_group_name='$unix_name'")) > 0) {
		$feedback .= _XF_REG_UNIXGROUPALREADYTAKEN;
	} else if (strlen($purpose) < 20) {
		$feedback .= _XF_REG_DESCRIBEREGISTRATION;
	} else if (strlen($description) < 10) {
		$feedback .= _XF_REG_DESCRIBEPROJECT;
	} else if (!$license) {
		$feedback .= _XF_REG_NOLICENSECHOSEN;
	} else if ($license != "other" && $license_other) {
		$feedback .= _XF_REG_CONFLICTLICENSE;
	} else if ($license == "other" && strlen($license_other) < 50) {
		$feedback .= _XF_REG_DESCRIBELICENSE;
	} else {
		$group = new Group();
		$res = $group->create(
			$xoopsUser,
			$full_name,
			$unix_name,
			$description,
			$license,
			$license_other,
			$purpose
		);

		if (!$res) {
			$feedback .= $group->getErrorMessage();
	                echo $feedback;
		} else {
		  if ($xoopsForge['manapprove'] == 1) {
			  echo "<p>"._XF_REG_ISSUBMITTED."</p>"
				    ."<p>"._XF_REG_THANKYOU."</p>";

			  CloseTable();
			  include("../../footer.php");
			
			  exit();
			} else if ($xoopsForge['manapprove'] == 0) 	{
	      if (!$group->approve($xoopsUser)) {
		      $feedback .= $group->getErrorMessage();
  	    } else {
            echo "<p>"._XF_REG_ISACTIVATED.":<br />";
  			    echo "<a href='".XOOPS_URL."/xf/project/?".$group->getUnixName()."'>".XOOPS_URL."/xf/project/?".$group->getUnixName()."</a><br />";
            echo _XF_REG_PROJECTSTATS."</p>"
                ."<p>"._XF_REG_THANKYOU."</p>";

			    CloseTable();
			    include("../../footer.php");
			    exit();
				}
			}
		}

	}
} else if ($i_disagree) {
	redirect_header(XOOPS_URL,4,_XF_REG_YOUDISAGREED);
	exit;
}

function includefile ($filename)
{
  global $xoopsConfig;

  if ( file_exists(XOOPS_ROOT_PATH."/xf/language/".$xoopsConfig['language']."/".$filename) ) {
    include(XOOPS_ROOT_PATH."/xf/language/".$xoopsConfig['language']."/".$filename);
  } else {
    include(XOOPS_ROOT_PATH."/xf/language/english/".$filename);
  }
}

?>
<B><font color=red><?php echo $feedback; ?></font></B>
<p>
<?php echo _XF_REG_TOAPPLYFILLIN; ?>
</p>

<form action="<?php echo $PHP_SELF; ?>" method="POST">

<H4>1. <?php echo _XF_REG_PrOJECTFULLNAME; ?></H4>

<?php includefile ("register_step_1.php"); ?>

<?php echo _XF_REG_FULLNAME; ?>:
<BR>
<INPUT size="40" maxlength="40" type=text name="full_name" value="<?php echo $ts->makeTboxData4Edit($full_name); ?>">

<H4>2. <?php echo _XF_REG_PROJECTPURPOSE; ?></H4>

<?php includefile ("register_step_2.php"); ?>

<font size="-1">
<TEXTAREA name="purpose" wrap="virtual" cols="70" rows="10">
<?php echo $ts->makeTareaData4Edit($purpose); ?>
</TEXTAREA>
</font>

<h4>3. <?php echo _XF_REG_LICENSE; ?></h4>

<?php includefile ("register_step_3.php"); ?>

<P><B><?php echo _XF_REG_LICENSES; ?></B>

<UL>
<LI><A href="http://www.opensource.org/licenses/gpl-license.html" target="_blank">GNU General Public License (GPL)</A>
<LI><A href="http://www.opensource.org/licenses/lgpl-license.html" target="_blank">GNU Library Public License (LGPL)</A>
<LI><A href="http://www.opensource.org/licenses/bsd-license.html" target="_blank">BSD License</A>
<LI><A href="http://www.opensource.org/licenses/mit-license.html" target="_blank">MIT License</A>
<LI><A href="http://www.opensource.org/licenses/artistic-license.html" target="_blank">Artistic License</A>
<LI><A href="http://www.opensource.org/licenses/mozilla1.0.html" target="_blank">Mozilla Public License 1.0 (MPL)</A>
<LI><A href="http://www.opensource.org/licenses/qtpl.html" target="_blank">Q Public License (QPL)</A>
<LI><A href="http://www.opensource.org/licenses/ibmpl.html" target="_blank">IBM Public License 1.0</A>
<LI><A href="http://www.opensource.org/licenses/mitrepl.html" target="_blank">MITRE Collaborative Virtual Workspace License (CVW License)</A>
<LI><A href="http://www.opensource.org/licenses/ricohpl.html" target="_blank">Ricoh Source Code Public License 1.0</A>
<LI><A href="http://www.opensource.org/licenses/pythonpl.html" target="_blank">Python License</A>
<LI><A href="http://www.opensource.org/licenses/zlib-license.html" target="_blank">zlib/libpng License</A>
<LI><A href="http://www.opensource.org/licenses/apachepl.html" target="_blank">Apache Software License</A>
<LI><A href="http://www.opensource.org/licenses/vovidapl.html" target="_blank">Vovida Software License 1.0</A>
<LI><A href="http://www.opensource.org/licenses/sisslpl.html" target="_blank">Sun Internet Standards Source License (SISSL)</A>
<LI><A href="http://www.opensource.org/licenses/intel-open-source-license.html" target="_blank">Intel Open Source License</A>
<LI><A href="http://www.opensource.org/licenses/mozilla1.1.html" target="_blank">Mozilla Public License 1.1 (MPL 1.1)</A>
<LI><A href="http://www.opensource.org/licenses/jabberpl.html" target="_blank">Jabber Open Source License</A>
<LI><A href="http://www.opensource.org/licenses/nokia.html" target="_blank">Nokia Open Source License</A>
<LI><A href="http://www.opensource.org/licenses/sleepycat.html" target="_blank">Sleepycat License</A>
<LI><A href="http://www.opensource.org/licenses/nethack.html" target="_blank">Nethack General Public License</A>
<LI><A href="http://oss.software.ibm.com/developerworks/opensource/license-cpl.html" target="_blank">IBM Common Public License</A>
<LI><A href="http://www.opensource.apple.com/apsl/" target="_blank">Apple Public Source License</A>
<LI><A href="http://www.sourceforge.net/register/publicdomain.txt" target="_blank">Public Domain</A>
<LI>Website Only
<LI>Other/Proprietary License

</UL>

<P><B><?php echo _XF_REG_LICENSEFORTHISPROJECT; ?></B>

<B><?php echo _XF_REG_YOURLICENSE; ?>:</B><BR>
<?php

// create SELECT based on $LICENSE array in common/include/vars.php
//
	echo '<SELECT NAME="license">';
	echo '<OPTION value="">(select)'."\n";
	while (list($k,$v) = each($LICENSE)) {
		print "<OPTION value=\"$k\"";
		if ($license == $k) {
			print " SELECTED";
		}
		print ">$v\n";
	}
	echo '</SELECT>';

?>

<?php includefile ("register_step_3a.php"); ?>

<BR>
<TEXTAREA name="license_other" wrap=virtual cols=60 rows=5>
<?php echo $ts->makeTareaData4Edit($license_other); ?>
</TEXTAREA>
<P>


<h4>4. <?php echo _XF_REG_PUBLICDESCRIPTION; ?></h4>

<?php includefile ("register_step_4.php"); ?>

<font size="-1">
<TEXTAREA name="description" wrap="virtual" cols="70" rows="5">
<?php echo $ts->makeTareaData4Edit($description); ?>
</TEXTAREA>
</font>

<H4>5. <?php echo _XF_REG_PROJECTUNIXNAME; ?></H4>

<?php includefile ("register_step_5.php"); ?>

<P><?php echo _XF_REG_UNIXNAME; ?>:
<BR>
<input type=text maxlength="15" SIZE="15" name="unix_name" value="<?php echo $ts->makeTboxData4Edit($unix_name); ?>">

<div align="center">
<input type=submit name="submit" value="<?php echo _XF_REG_IAGREE; ?>"> <INPUT type=submit name="i_disagree" value="<?php echo _XF_REG_IDISAGREE; ?>">
</div>

</form>

<?php
CloseTable();
include("../../footer.php");
?>

