<?php
/**
  *
  * SourceForge Code Snippets Repository
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: add_snippet_to_package.php,v 1.2 2002/05/29 18:55:28 arjenvanefferen Exp $
  *
  */
include_once ("../../mainfile.php");

$langfile="snippet.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/snippet/snippet_utils.php");

function handle_add_exit() {
	global $suppress_nav;
        if ($suppress_nav) {
            echo '';
        } else {
            snippet_footer();
        }
	exit;
}

if ($xoopsUser) {

	snippet_header(_XF_SNP_SUBMITNEWSNIPPET);

	if (!$snippet_package_version_id) {
		//make sure the package id was passed in
		echo '<H4>Error - snippet_package_version_id missing</H4>';
    snippet_footer();
		exit;
	}

	if ($post_changes) {
		/*
			Create a new snippet entry, then create a new snippet version entry
		*/
		if ($snippet_package_version_id && $snippet_version_id) {
			/*
				check to see if they are the creator of this version
			*/
			$result = $xoopsDB->query("SELECT * FROM ".$xoopsDB->prefix("xf_snippet_package_version")." "
			                         ."WHERE submitted_by='".$xoopsUser->getVar("uid")."' AND "
						                   ."snippet_package_version_id='$snippet_package_version_id'");
																
			if (!$result || $xoopsDB->getRowsNum($result) < 1) {
				echo '<H4>'._XF_SNP_ONLYCREATORCANADDTOPACKAGE.'</H4>';
        snippet_footer();
		    exit;
			}

			/*
				make sure the snippet_version_id exists
			*/
			$result = $xoopsDB->query("SELECT * FROM ".$xoopsDB->prefix("xf_snippet_version")." WHERE snippet_version_id='$snippet_version_id'");
			
			if (!$result || $xoopsDB->getRowsNum($result) < 1) {
				echo "<H4>"._XF_SNP_SNIPPETDOESNOTEXIST."</H4>";
				echo '<A HREF="'.XOOPS_URL.'/xf/snippet/add_snippet_to_package.php?snippet_package_version_id='.$snippet_package_version_id.'">'._XF_SNP_BACKTOADDPAGE.'</A>';
        snippet_footer();
		    exit;
			}

			/*
				make sure the snippet_version_id isn't already in this package
			*/
			$result = $xoopsDB->query("SELECT * FROM ".$xoopsDB->prefix("xf_snippet_package_item")." "
			                         ."WHERE snippet_package_version_id='$snippet_package_version_id' "
											         ."AND snippet_version_id='$snippet_version_id'");
												
			if ($result && $xoopsDB->getRowsNum($result) > 0) {
				echo '<H4>'._XF_SNP_SNIPPETALREADYADDEDTOPACKAGE.'</H4>';
				echo '<A HREF="'.XOOPS_URL.'/xf/snippet/add_snippet_to_package.php?snippet_package_version_id='.$snippet_package_version_id.'">'._XF_SNP_BACKTOADDPAGE.'</A>';
        snippet_footer();
		    exit;
			}

			/*
				create the snippet version
			*/
			$sql = "INSERT INTO ".$xoopsDB->prefix("xf_snippet_package_item")." (snippet_package_version_id,snippet_version_id) "
			      ."VALUES ('$snippet_package_version_id','$snippet_version_id')";

			$result = $xoopsDB->queryF($sql);

			if (!$result) {
				$feedback .= ' ERROR DOING SNIPPET VERSION INSERT! ';
				echo $xoopsDB->error();
			} else {
				$feedback .= ' '._XF_SNP_SNIPPETVERSIONADDED.' ';
			}
		} else {
			echo '<H4>'._XF_SNP_GOBACKFILLALLINFO.'</H4>';
			echo '<A HREF="'.XOOPS_URL.'/xf/snippet/add_snippet_to_package.php?snippet_package_version_id='.$snippet_package_version_id.'">'._XF_SNP_BACKTOADDPAGE.'</A>';
      snippet_footer();
      exit;
		}

	}

	$result = $xoopsDB->query("SELECT sp.name,spv.version "
	                         ."FROM ".$xoopsDB->prefix("xf_snippet_package")." sp,".$xoopsDB->prefix("xf_snippet_package_version")." spv "
													 ."WHERE sp.snippet_package_id=spv.snippet_package_id "
													 ."AND spv.snippet_package_version_id='$snippet_package_version_id'");

	?>
	<P>
	<B><?php echo _XF_SNP_PACKAGE; ?>:</B><BR>
	<?php echo $ts->makeTboxData4Show(unofficial_getDBResult($result,0,'name')) . ' -  ' . $ts->makeTboxData4Show(unofficial_getDBResult($result,0,'version')); ?>
	<P>
	<?php echo _XF_SNP_CANUSEFORMREPEATEDLY; ?>
	<P>
	<?php echo _XF_SNP_VERSIONIDISUNIQUE; ?>
	<P>
	<FORM ACTION="<?php echo $PHP_SELF; ?>" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="post_changes" VALUE="y">
	<INPUT TYPE="HIDDEN" NAME="snippet_package_version_id" VALUE="<?php echo $snippet_package_version_id; ?>">
	<INPUT TYPE="HIDDEN" NAME="suppress_nav" VALUE="<?php echo $suppress_nav; ?>">

	<TABLE>
	<TR><TD COLSPAN="2" ALIGN="MIDDLE">
		<B><?php echo _XF_SNP_ADDSNIPPETVERSION; ?>:</B><BR>
		<INPUT TYPE="TEXT" NAME="snippet_version_id" SIZE="6" MAXLENGTH="7">
	</TD></TR>

	<TR><TD COLSPAN="2" ALIGN="MIDDLE">
		<B><?php echo _XF_SNP_MAKESUREALLCOMPLETE; ?></B>
		<BR>
		<INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="<?php echo _XF_G_SUBMIT; ?>">
	</TD></TR>
	</FORM>
	</TABLE>
	<?php
	/*
		Show the snippets in this package
	*/
	$result = $xoopsDB->query("SELECT spi.snippet_version_id, sv.version, s.name "
	                         ."FROM ".$xoopsDB->prefix("xf_snippet")." s,".$xoopsDB->prefix("xf_snippet_version")." sv,".$xoopsDB->prefix("xf_snippet_package_item")." spi "
													 ."WHERE s.snippet_id=sv.snippet_id "
													 ."AND sv.snippet_version_id=spi.snippet_version_id "
													 ."AND spi.snippet_package_version_id='$snippet_package_version_id'");

	$rows = $xoopsDB->getRowsNum($result);

	if (!$result || $rows < 1) {
		echo $xoopsDB->error();
		echo '
		<P>'._XF_SNP_NOSNIPPETSINPACKAGE;
	} else {
  	$title = _XF_SNP_SNIPPETSINPACKAGE;
		$content = "<table border='0' width='100%'>";

		for ($i=0; $i<$rows; $i++) {
			$content .= '
			<TR class="'.($i%2>0?'bg1':'bg3').'"><TD ALIGN="MIDDLE">
				<A HREF="'.XOOPS_URL.'/xf/snippet/delete.php?type=frompackage&snippet_version_id='.
				unofficial_getDBResult($result,$i,'snippet_version_id').
				'&snippet_package_version_id='.$snippet_package_version_id.
				'"><img src="'.XOOPS_URL.'/xf/images/ic/trash.png" width="16" height="16" border="0"></A></TD><TD WIDTH="99%">'.
				$ts->makeTboxData4Show(unofficial_getDBResult($result,$i,'name')).' '.$ts->makeTboxData4Showunofficial_getDBResult($result,$i,'version'))."</TD></TR>";

			$last_group = unofficial_getDBResult($result,$i,'group_id');
		}
		$content .= "</table>";

	  themesidebox($title, $content);
	}
	echo '
	<P>
	<H4><FONT COLOR="RED">'.$feedback.'</FONT></H4>';

  snippet_footer();
  exit;
} else {

  redirect_header(XOOPS_URL."/user.php", 2,_NOPERM);
  exit;

}

?>
