<?php
/**
  *
  * SourceForge Code Snippets Repository
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: detail.php,v 1.2 2002/05/29 18:55:28 arjenvanefferen Exp $
  *
  */
include_once ("../../mainfile.php");

$langfile="snippet.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/snippet/snippet_utils.php");

/*
	Show a detail page for either a snippet or a package
	or a specific version of a package
*/

if ($type == 'snippet') {
	/*
		View a snippet and show its versions
		Expand and show the code for the latest version
	*/

	snippet_header(_XF_SNP_SNIPPETLIBRARY);

	snippet_show_snippet_details($id);

	/*
		Get all the versions of this snippet
	*/
	$sql = "SELECT u.uname,sv.snippet_version_id,sv.version,sv.date,sv.changes "
	      ."FROM ".$xoopsDB->prefix("xf_snippet_version")." sv,".$xoopsDB->prefix("users")." u "
				."WHERE u.uid=sv.submitted_by "
				."AND snippet_id='$id' "
				."ORDER BY sv.snippet_version_id DESC";

	$result = $xoopsDB->query($sql);
	$rows = $xoopsDB->getRowsNum($result);
	
	if (!$result || $rows < 1) {
		echo '<H4>Error - no versions found</H4>';
	} else {
		echo '
		<H4>'._XF_SNP_VERSIONSOFSNIPPET.':</H4>
		<P>';
    echo "<table border='0' width='100%'>"
	      ."<tr class='bg2'>"
		  	."<td><b>"._XF_SNP_SNIPPETID."</b></td>"
		  	."<td><b>"._XF_SNP_DOWNLOADVERSION."</b></td>"
        ."<td><b>"._XF_SNP_DATEPOSTED."</b></td>"
        ."<td><b>"._XF_SNP_AUTHOR."</b></td>"
        ."<td><b>"._XF_G_DELETE."</b></td>"
  	    ."</tr>";

		/*
			get the newest version of this snippet, so we can display its code
		*/
		$newest_version = unofficial_getDBResult($result,0,'snippet_version_id');

		for ($i=0; $i<$rows; $i++) {
			echo '
				<TR class="'.($i%2>0?'bg1':'bg3').'"><TD>'.unofficial_getDBResult($result,$i,'snippet_version_id').
				'</TD><TD><A HREF="'.XOOPS_URL.'/xf/snippet/download.php?type=snippet&id='.
				unofficial_getDBResult($result,$i,'snippet_version_id').'"><B>'.
				$ts->makeTboxData4Show(unofficial_getDBResult($result,$i,'version')).'</B></A></TD><TD>'. 
				date($sys_datefmt,unofficial_getDBResult($result,$i,'date')).'</TD><TD>'.
				unofficial_getDBResult($result,$i,'uname').'</TD><TD ALIGN="MIDDLE"><A HREF="'.XOOPS_URL.'/xf/snippet/delete.php?type=snippet&snippet_version_id='.
				unofficial_getDBResult($result,$i,'snippet_version_id').
				'"><img src="'.XOOPS_URL.'/xf/images/ic/trash.png" width="16" height="16" border="0"></A></TD></TR>';

				if ($i != ($rows - 1)) {
					echo '
					<TR class="'.($i%2>0?'bg1':'bg3').'"><TD COLSPAN=5>'._XF_SNP_CHANGESSINCELASTVERSION.':<BR>'.
					$ts->makeTareaData4Show(unofficial_getDBResult($result,$i,'changes')).'</TD></TR>';
				}
		}
		echo '</TABLE>';

		echo '<P>'._XF_SNP_DOWNLOADRAWTEXT.'<P>';
	}
	/*
		show the latest version of this snippet's code
	*/
	$result = $xoopsDB->query("SELECT code,version FROM ".$xoopsDB->prefix("xf_snippet_version")." WHERE snippet_version_id='$newest_version'");	

	echo '
		<P>
		<HR>
		<P>
		<H4>'._XF_SNP_LATESTVERSION.': '.$ts->makeTboxData4Show(unofficial_getDBResult($result,0,'version')).'</H4>
		<P>
		<PRE><FONT SIZE="-1">'.$ts->makeTboxData4Edit(unofficial_getDBResult($result,0,'code')).'</FONT></PRE>
		<P>';
	/*
		Show a link so you can add a new version of this snippet
	*/
	echo '
	<H4><A HREF="'.XOOPS_URL.'/xf/snippet/addversion.php?type=snippet&id='.$id.'"><FONT COLOR="RED">'._XF_SNP_SUBMITNEWSNIPPETVERSION.'</FONT></A></H4>
	<P>'._XF_SNP_YOUCANSUBMITIFMODIFIED;

	snippet_footer();

} else if ($type=='package') {
	/*
		View a package and show its versions
		Expand and show the snippets for the latest version
	*/

	snippet_header(_XF_SNP_SNIPPETLIBRARY);

	snippet_show_package_details($id);

	/*
		Get all the versions of this package
	*/
	$sql = "SELECT u.uname,spv.snippet_package_version_id,spv.version,spv.date "
	      ."FROM ".$xoopsDB->prefix("xf_snippet_package_version")." spv,".$xoopsDB->prefix("users")." u "
				."WHERE u.uid=spv.submitted_by "
				."AND snippet_package_id='$id' "
				."ORDER BY spv.snippet_package_version_id DESC";

	$result = $xoopsDB->query($sql);
	$rows = $xoopsDB->getRowsNum($result);
	if (!$result || $rows < 1) {
		echo '<H4>Error - no versions found</H4>';
	} else {
		echo '
		<H4>'._XF_SNP_VERSIONSOFPACKAGE.':</H4>
		<P>';
    echo "<table border='0' width='100%'>"
	      ."<tr class='bg2'>"
		  	."<td><b>"._XF_SNP_PACKAGEVERSION."</b></td>"
        ."<td><b>"._XF_SNP_DATEPOSTED."</b></td>"
        ."<td><b>"._XF_SNP_AUTHOR."</b></td>"
        ."<td><b>"._XF_SNP_EDITDEL."</b></td>"
  	    ."</tr>";

		/*
			determine the newest version of this package, 
			so we can display the snippets that it contains
		*/
		$newest_version = unofficial_getDBResult($result,0,'snippet_package_version_id');

		for ($i=0; $i<$rows; $i++) {
			echo '
			<TR class="'.($i%2>0?"bg1":"bg3").'"><TD><A HREF="'.XOOPS_URL.'/xf/snippet/detail.php?type=packagever&id='.
				unofficial_getDBResult($result,$i,'snippet_package_version_id').'"><B>'.
				$ts->makeTboxData4Show(unofficial_getDBResult($result,$i,'version')).'</B></A></TD><TD>'.
				date($sys_datefmt,unofficial_getDBResult($result,$i,'date')).'</TD><TD>'.
				unofficial_getDBResult($result,$i,'uname').
				'</TD><TD ALIGN="MIDDLE"><A HREF="'.XOOPS_URL.'/xf/snippet/add_snippet_to_package.php?snippet_package_version_id='.
				unofficial_getDBResult($result,$i,'snippet_package_version_id').
				'"><img src="'.XOOPS_URL.'/xf/images/ic/pencil.png" width="16" height="16" border="0">' .
				'</A> &nbsp; &nbsp; &nbsp; <A HREF="'.XOOPS_URL.'/xf/snippet/delete.php?type=package&snippet_package_version_id='.
				unofficial_getDBResult($result,$i,'snippet_package_version_id').
				'"><img src="'.XOOPS_URL.'/xf/images/ic/trash.png" width="16" height="16" border="0"></A></TD></TR>';
		}
		echo '</TABLE>';

		echo '
		<P>'._XF_SNP_DOWNLOADRAWTEXT.'<P>';
	}

	/*
		show the latest version of the package
		and its snippets
	*/

	echo '
		<P>
		<HR>
		<P>
		<H4>'._XF_SNP_LATESTPACKAGEVERSION.': '.$ts->makeTboxData4Show(unofficial_getDBResult($result,0,'version')).'</H4>
		<P>
		<P>';
	snippet_show_package_snippets($newest_version);

	/*
		Show a form so you can add a new version of this package
	*/
	echo '
	<H4><A HREF="'.XOOPS_URL.'/xf/snippet/addversion.php?type=package&id='.$id.'"><FONT COLOR="RED">'._XF_SNP_SUBMITNEWVERSION.'</FONT></A></H4>
	<P>'._XF_SNP_YOUCANSUBMITIFMODIFIEDPACKAGE;

	snippet_footer();

} else if ($type == 'packagever') {
	/*
		Show a specific version of a package and its specific snippet versions
	*/
	
	snippet_header(_XF_SNP_SNIPPETLIBRARY);

	snippet_show_package_details($id);

	snippet_show_package_snippets($id);

	snippet_footer();

} else {

  echo 'Error<br />Error - was the URL mangled?';

}

?>
