<?php
/**
  *
  * SourceForge Code Snippets Repository
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: snippet_utils.php,v 1.2 2002/05/29 18:55:28 arjenvanefferen Exp $
  *
  */


/*
	Code Snippet System
	By Tim Perdue, Sourceforge, Jan 2000
*/

$SCRIPT_LICENSE = array();
$SCRIPT_LICENSE[0] = 'GNU General Public License';
$SCRIPT_LICENSE[1] = 'GNU Library Public License';
$SCRIPT_LICENSE[2] = 'BSD License';
$SCRIPT_LICENSE[3] = 'MIT/X Consortium License';
$SCRIPT_LICENSE[4] = 'Artistic License';
$SCRIPT_LICENSE[5] = 'Mozilla Public License';
$SCRIPT_LICENSE[6] = 'Qt Public License';
$SCRIPT_LICENSE[7] = 'IBM Public License';
$SCRIPT_LICENSE[8] = 'Collaborative Virtual Workspace License';
$SCRIPT_LICENSE[9] = 'Ricoh Source Code Public License';
$SCRIPT_LICENSE[10] = 'Python License';
$SCRIPT_LICENSE[11] = 'zlib/libpng License';
$SCRIPT_LICENSE[12] = 'WebSite Only';
$SCRIPT_LICENSE[13] = 'Other';

function snippet_header($title) {
  global $xoopsForge, $feedback;

  include (XOOPS_ROOT_PATH."/header.php");
  OpenTable();

  echo "<H4>$title</H4>";
  echo '<P><B>';
	echo '<A HREF="'.XOOPS_URL.'/xf/snippet/">'._XF_SNP_BROWSE.'</A>
		 | <A HREF="'.XOOPS_URL.'/xf/snippet/submit.php">'._XF_SNP_SUBMITNEWSNIPPET.'</A>
		 | <A HREF="'.XOOPS_URL.'/xf/snippet/package.php">'._XF_SNP_CREATEAPACKAGE.'</A></B>';
	echo '<br /><font color="red">'.$feedback.'</font><br />';
}

function snippet_footer($params) {
  CloseTable();
  include (XOOPS_ROOT_PATH."/footer.php");
}

function snippet_show_package_snippets($version) {
  global $xoopsDB;
	
	//show the latest version
	$sql = "SELECT spi.snippet_version_id,sv.version,s.name,u.uname "
		    ."FROM ".$xoopsDB->prefix("xf_snippet")." s,".$xoopsDB->prefix("xf_snippet_version")." sv,".$xoopsDB->prefix("xf_snippet_package_item")." spi,".$xoopsDB->prefix("users")." u "
				."WHERE s.snippet_id=sv.snippet_id "
				."AND u.uid=sv.submitted_by "
				."AND sv.snippet_version_id=spi.snippet_version_id "
				."AND spi.snippet_package_version_id='$version'";

	$result = $xoopsDB->query($sql);
	$rows = $xoopsDB->getRowsNum($result);
	echo '
	<P>
	<H4>'._XF_SNP_SNIPPETSINPACKAGE.':</H4>
	<P>';

   echo "<table border='0' width='100%'>"
       ."<tr class='bg2'>"
       ."<td><b>"._XF_SNP_SNIPPETID."</b></td>"
       ."<td><b>"._XF_SNP_DOWNLOADVERSION."</b></td>"
       ."<td><b>"._XF_SNP_TITLE."</b></td>"
       ."<td><b>"._XF_SNP_AUTHOR."</b></td>"
  	   ."</tr>";

	if (!$result || $rows < 1) {
		echo $xoopsDB->error();
		echo '
			<TR><TD COLSPAN="4"><H4>'._XF_SNP_NOSNIPPETSINPACKAGE.'</H4></TD></TR>';
	} else {

		//get the newest version, so we can display it's code
		$newest_version = unofficial_getDBResult($result,0,'snippet_version_id');

		for ($i=0; $i<$rows; $i++) {
			echo '
			<TR class="'.($i%2>0?'bg1':'bg3').'"><TD>'.unofficial_getDBResult($result,$i,'snippet_version_id').
				'</TD><TD><A HREF="'.XOOPS_URL.'/xf/snippet/download.php?type=snippet&id='.
				unofficial_getDBResult($result,$i,'snippet_version_id').'">'.
				$ts->makeTboxData4Show(unofficial_getDBResult($result,$i,'version')).'</A></TD><TD>'.
				$ts->makeTboxData4Show(unofficial_getDBResult($result,$i,'name')).'</TD><TD>'.
				unofficial_getDBResult($result,$i,'user_name').'</TD></TR>';
		}
	}
	echo '</TABLE>';

}

function snippet_show_package_details($id) {
	global $xoopsDB;

	$sql = "SELECT sp.name,sp.description,sl.name,sc.name "
	      ."FROM ".$xoopsDB->prefix("xf_snippet_package")." sp,".$xoopsDB->prefix("xf_snippet_language")." sl,".$xoopsDB->prefix("xf_snippet_category")." sc "
				."WHERE snippet_package_id='$id' "
				."AND sl.type_id=sp.language "
				."AND sc.type_id=sp.category";
				
	list($name,$description,$language,$category) = $xoopsDB->fetchArray($xoopsDB->query($sql));

	echo '
	<P>
	<TABLE WIDTH="100%" BORDER="0" CELLSPACING="1" CELLPADDING="2">

	<TR><TD COLSPAN="2">
	<H2>'. $name.'</H2>
	</TD></TR>

	<TR>
		<TD><B>'._XF_SNP_CATEGORY.':</B><BR>
		'.$category.'
		</TD>

		<TD><B>'._XF_SNP_LANGUAGE.':</B><BR>
		'.$language.'
		</TD>
	</TR>

	<TR><TD COLSPAN="2">&nbsp;<BR><B>'._XF_G_DESCRIPTION.':</B><BR>
	'. $ts->makeTareaData4Show($description).'
	</TD></TR>

	</TABLE>';

}

function snippet_show_snippet_details($id) {
	global $SCRIPT_LICENSE, $xoopsDB;

	$sql = "SELECT s.name,s.description,s.license,st.name,sl.name,sc.name "
	      ."FROM ".$xoopsDB->prefix("xf_snippet_package")." s,".$xoopsDB->prefix("xf_snippet_language")." sl,".$xoopsDB->prefix("xf_snippet_category")." sc,".$xoopsDB->prefix("xf_snippet_type")." st "
				."WHERE snippet_package_id='$id' "
				."AND st.type_id=sp.type "
				."AND sl.type_id=sp.language "
				."AND sc.type_id=sp.category";
				
	list($name,$description,$type,$language,$category) = $xoopsDB->fetchArray($xoopsDB->query($sql));

	echo '
	<P>
	<TABLE WIDTH="100%" BORDER="0" CELLSPACING="1" CELLPADDING="2">

	<TR><TD COLSPAN="2">
	<H4>'. $name.'</H2>
	</TD></TR>

	<TR><TD><B>'._XF_SNP_TYPE.':</B><BR>
		'.$type.'</TD>
	<TD><B>'._XF_SNP_CATEGORY.':</B><BR>
		'.$category.'
	</TD></TR>

	<TR><TD><B>'._XF_SNP_LICENSE.':</B><BR>
		'.$SCRIPT_LICENSE[$license].'</TD>
	<TD><B>'._XF_SNP_LANGUAGE.':</B><BR>
		'.$language.'
	</TD></TR>

	<TR><TD COLSPAN="2">&nbsp;<BR>
	<B>'._XF_G_DESCRIPTION.':</B><BR>
	'. $ts->makeTareaData4Show($description).'
	</TD></TR>

	</TABLE>';
}

?>
