<?php
/**
  *
  * SourceForge Survey Facility
  *
  * SourceForge: Breaking Down the Barriers to Open Source Development
  * Copyright 1999-2001 (c) VA Linux Systems
  * http://sourceforge.net
  *
  * @version   $Id: show_results_aggregate.php,v 1.3 2002/06/07 09:17:34 arjenvanefferen Exp $
  *
  */
include_once ("../../../mainfile.php");

$langfile="survey.php";
require_once(XOOPS_ROOT_PATH."/xf/include/pre.php");
require_once(XOOPS_ROOT_PATH."/xf/include/project_summary.php");
require_once(XOOPS_ROOT_PATH."/xf/survey/survey_utils.php");
require_once(XOOPS_ROOT_PATH."/xf/include/HTML_Graphs.php");

project_check_access ($group_id);

// get current information
$group =& group_get_object($group_id);
$perm  =& $group->getPermission( $xoopsUser );

survey_header($group, _XF_SUR_SURVEYAGGREGATERESULTS, 'is_admin_page');
	
/*
	Select this survey from the database
*/

$sql = "SELECT * FROM ".$xoopsDB->prefix("xf_surveys")." WHERE survey_id='$survey_id' AND group_id='$group_id'";
$result = $xoopsDB->query($sql);

echo "<H4>".$ts->makeTboxData4Show(unofficial_getDBResult($result, 0, "survey_title"))."</H4><P>";

/*
	Select the questions for this survey
*/

$questions = unofficial_getDBResult($result, 0, "survey_questions");
$questions = str_replace(" ", "", $questions);
$quest_array = explode(',', $questions);
$count = count($quest_array);

echo "\n\n<TABLE>";

$q_num=1;

for ($i=0; $i<$count; $i++) {

	/*
		Build the questions on the HTML form
	*/

	$sql = "SELECT question_type,question,question_id FROM ".$xoopsDB->prefix("xf_survey_questions")." WHERE question_id='".$quest_array[$i]."' AND group_id='$group_id'";
	$result = $xoopsDB->query($sql);

	$question_type = unofficial_getDBResult($result, 0, "question_type");

	if ($question_type == "4") {
		/*
			Don't show question number if it's just a comment
		*/

		echo "\n<TR><TD VALIGN=TOP>&nbsp;</TD>\n<TD>"; 

	} else {

		echo "\n<TR><TD VALIGN=TOP><B>";

		/*
			If it's a 1-5 question box and first in series, move Quest
			number down a bit
		*/

		if (($question_type != $last_question_type) && (($question_type == "1") || ($question_type == "3"))) {
			echo "&nbsp;<P>";
		}

		echo $q_num."&nbsp;&nbsp;&nbsp;&nbsp;<BR></TD>\n<TD>";
		$q_num++;

	}
	
	if ($question_type == "1") {

		/*
			This is a rdio-button question. Values 1-5.	
		*/

		# Show the 1-5 markers only if this is the first in a series

		if ($question_type != $last_question_type) {
			echo "\n<B>1 &nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp; 5</B>\n";
			echo "<BR>";

		}

		/*
			Select the number of responses to this question
		*/
		$sql = "SELECT COUNT(*) AS count FROM ".$xoopsDB->prefix("xf_survey_responses")." WHERE survey_id='$survey_id' AND question_id='$quest_array[$i]' AND response IN (1,2,3,4,5) AND group_id='$group_id'";

		$result2 = $xoopsDB->query($sql);
		if (!$result2 || $xoopsDB->getRowsNum($result2) < 1) {
			echo "error";
			echo $xoopsDB->error();
		} else {
			$response_count = unofficial_getDBResult($result2, 0, 'count');
			echo "<B>" . $response_count . "</B> "._XF_SUR_RESPONSES."<BR>";
		}
		/*
			average
		*/
		if ($response_count > 0){
			$sql = "SELECT AVG(response) AS avg FROM ".$xoopsDB->prefix("xf_survey_responses")." WHERE survey_id='$survey_id' AND question_id='$quest_array[$i]' AND group_id='$group_id'";
		  $result2 = $xoopsDB->query($sql);
			if (!$result2 || $xoopsDB->getRowsNum($result2) < 1) {
				echo "error";
				echo $xoopsDB->error();
			} else {
				echo "<B>".unofficial_getDBResult($result2, 0, 'avg')."</B> "._XF_SUR_AVERAGE;
			}
			
			$sql = "SELECT response,COUNT(*) AS count FROM ".$xoopsDB->prefix("xf_survey_responses")." WHERE survey_id='$survey_id' AND question_id='$quest_array[$i]' AND group_id='$group_id' GROUP BY response";
		  $result2 = $xoopsDB->query($sql);
			if (!$result2 || $xoopsDB->getRowsNum($result2) < 1) {
				echo "error";
				echo $xoopsDB->error();
			} else {
				GraphResult($result2,$ts->makeTboxData4Show(unofficial_getDBResult($result, 0, "question")));
			}
		}// end if (responses to survey question present)
	} else if ($question_type == "2") {
		/*
			This is a text-area question.
		*/

		echo $ts->makeTboxData4Show(unofficial_getDBResult($result, 0, "question"))."<BR>\n";

		echo "<A HREF='show_results_comments.php?survey_id=$survey_id&question_id=$quest_array[$i]&group_id=$group_id'>"._XF_SUR_VIEWCOMMENTS."</A>";

	} else if ($question_type == "3") {
		/*
			This is a Yes/No question.
		*/

		/*
			Show the Yes/No only if this is the first in a series
		*/

		if ($question_type != $last_question_type) {
			echo "<B>Yes / No</B><BR>\n";
		}

		/*
			Select the count and average of responses to this question
		*/
		$sql = "SELECT COUNT(*) AS count FROM ".$xoopsDB->prefix("xf_survey_responses")." WHERE survey_id='$survey_id' AND question_id='$quest_array[$i]' AND group_id='$group_id' AND response IN (1,5)";
	  $result2 = $xoopsDB->query($sql);
		if (!$result2 || $xoopsDB->getRowsNum($result2) < 1) {
			echo "error";
  		echo $xoopsDB->error();
		} else {
			echo "<B>".unofficial_getDBResult($result2, 0, 0)."</B> "._XF_SUR_RESPONSES."<BR>";
		}
		/*
			average
		*/
		$sql = "SELECT AVG(response) AS avg FROM ".$xoopsDB->prefix("xf_survey_responses")." WHERE survey_id='$survey_id' AND question_id='$quest_array[$i]' AND group_id='$group_id'";
	  $result2 = $xoopsDB->query($sql);
		if (!$result2 || $xoopsDB->getRowsNum($result2) < 1) {
			echo "error";
  		echo $xoopsDB->error();
		} else {
			echo "<B>".unofficial_getDBResult($result2, 0, 0)."</B> "._XF_SUR_AVERAGE;
		}

		/*
			Get the YES responses
		*/
		$sql = "SELECT COUNT(*) AS count FROM ".$xoopsDB->prefix("xf_survey_responses")." WHERE survey_id='$survey_id' AND question_id='$quest_array[$i]' AND group_id='$group_id' AND response='1'";
	  $result2 = $xoopsDB->query($sql);

		$name_array[0] = "Yes";

		if (!$result2 || $xoopsDB->getRowsNum($result2) < 1) {
			$value_array[0] = 0;
		} else {
			$value_array[0] = unofficial_getDBResult($result2, 0, "count");
		}

		/*
			Get the NO responses
		*/
		$sql = "SELECT COUNT(*) AS count FROM ".$xoopsDB->prefix("xf_survey_responses")." WHERE survey_id='$survey_id' AND question_id='$quest_array[$i]' AND group_id='$group_id' AND response='5'";
	  $result2 = $xoopsDB->query($sql);

		$name_array[1]="No";

		if (!$result2 || $xoopsDB->getRowsNum($result2) < 1) {
			$value_array[1] = 0;
		} else {
			$value_array[1] = unofficial_getDBResult($result2, 0, "count");
		}
		GraphIt($name_array,$value_array,$ts->makeTboxData4Show(unofficial_getDBResult($result, 0, "question")));

	} else if ($question_type == "4") {

		/*
			This is a comment only.
		*/

		echo "&nbsp;<P><B>".$ts->makeTboxData4Show(unofficial_getDBResult($result, 0, "question"))."</B>\n";
		echo "<INPUT TYPE='HIDDEN' NAME='_".$quest_array[$i]."' VALUE='-666'>";

	} else if ($question_type == "5") {

		/*
			This is a text-field question.
		*/

		echo $ts->makeTboxData4Show(unofficial_getDBResult($result, 0, "question"))."<BR>\n";

		echo "<A HREF='show_results_comments.php?survey_id=$survey_id&question_id=$quest_array[$i]&group_id=$group_id'>"._XF_SUR_VIEWCOMMENTS."</A>";

	}

	echo "</TD></TR>";

	$last_question_type = $question_type;

}

echo "\n\n</TABLE>";

survey_footer();

?>
